config_mypath(): allow setting additional $PATH
[grml-autoconfig.git] / autoconfig.functions
1 #!/bin/zsh
2 # Filename:      autoconfig.functions
3 # Purpose:       basic system configuration and hardware setup for grml system
4 # Authors:       grml-team (grml.org), (c) Klaus Knopper <knopper@knopper.net>, (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Sat Mar 22 00:41:14 CET 2008 [mika]
8 ################################################################################
9
10 # {{{ path, variables, signals, umask, zsh
11 export PATH="/bin:/sbin:/usr/bin:/usr/sbin:/usr/X11R6/bin"
12 DEBUG="/dev/null"
13 KERNEL="$(uname -r)"
14 umask 022
15
16 # old linuxrc version:
17 [ -d /cdrom ]      && export LIVECD_PATH=/cdrom
18 # new initramfs layout:
19 [ -d /live/image ] && export LIVECD_PATH=/live/image
20
21 # Ignore these signals in non-interactive mode: INT, TERM, SEGV
22 [ -z "$PS1" ] && trap "" 2 3 11
23
24 # zsh stuff
25 iszsh(){
26 if [ -n "$ZSH_VERSION" ] ; then
27   return 0
28 else
29   return 1
30 fi
31 }
32 # avoid 'no matches found: ...'
33 iszsh && setopt no_nomatch # || echo "Warning: not running under zsh!"
34 # }}}
35
36 ### {{{ Utility Functions
37
38 # Simple shell grep
39 stringinfile(){
40   case "$(cat $2)" in *$1*) return 0;; esac
41   return 1
42 }
43
44 # same for strings
45 stringinstring(){
46   case "$2" in *$1*) return 0;; esac
47   return 1
48 }
49
50 # Reread boot command line; echo last parameter's argument or return false.
51 getbootparam(){
52   stringinstring " $1=" "$CMDLINE" || return 1
53   result="${CMDLINE##*$1=}"
54   result="${result%%[   ]*}"
55   echo "$result"
56   return 0
57 }
58
59 # Check boot commandline for specified option
60 checkbootparam(){
61   stringinstring " $1" "$CMDLINE"
62   return "$?"
63 }
64
65 checkvalue(){
66   if [ "$1" = "yes" ] ; then
67     return 0
68   else
69     return 1
70   fi
71 }
72
73 checkgrmlsmall(){
74   grep -q small /etc/grml_version 2>>$DEBUG && return 0 || return 1
75 }
76
77 checkgrmlusb(){
78   grep -q usb /etc/grml_version 2>>$DEBUG && return 0 || return 1
79 }
80 ### }}}
81
82 # {{{ filesystems (proc, pts, sys) and fixes
83 mount_proc(){
84   [ -f /proc/version ] || mount -t proc /proc /proc 2>/dev/null
85 }
86
87 mount_pts(){
88   stringinfile "/dev/pts" /proc/mounts || mount -t devpts /dev/pts /dev/pts 2>/dev/null
89 }
90
91 mount_sys(){
92   [ -d /sys/devices ] || mount -t sysfs /sys /sys 2>/dev/null
93 }
94 # }}}
95
96 # {{{ Read in boot parameters
97 [ -f /proc/version ] || mount_proc # make sure we can access /proc/cmdline when sourcing this file too
98 CMDLINE="$(cat /proc/cmdline)"
99 [ -d "${LIVECD_PATH}"/bootparams/ ] && CMDLINE="$CMDLINE $(cat ${LIVECD_PATH}/bootparams/* | tr '\n' ' ')"
100 # }}}
101
102 # {{{ Check if we are running from the grml-CD or HD
103 INSTALLED=""
104 [ -e /etc/grml_cd ] || INSTALLED="yes"
105
106 # testcd
107 TESTCD=""
108 checkbootparam "testcd" >>$DEBUG 2>&1 && TESTCD="yes"
109 # }}}
110
111 # {{{ source lsb-functions , color handling
112 if checkbootparam "nocolor"; then
113   RC_NOCOLOR=yes
114   . /etc/grml/lsb-functions
115   einfo "Disabling colors in bootsequence as requested on commandline." ; eend 0
116 else
117   . /etc/grml/lsb-functions
118   . /etc/grml_colors
119 fi
120 # }}}
121
122 # {{{ debug
123 config_debug(){
124  checkbootparam "debug"                        && BOOTDEBUG="yes"
125  stringinstring "BOOT_IMAGE=debug " "$CMDLINE" && BOOTDEBUG="yes"
126
127  rundebugshell(){
128   if [ -n "$BOOTDEBUG" ]; then
129      einfo "Starting intermediate shell stage $stage as requested by \"debug\" option."
130      if [ grep -q "debug=noscreen" "$CMDLINE" ] ; then
131         /bin/zsh
132      else
133         eindent
134         if [ -r /etc/grml/screenrc ] ; then
135            einfo "Starting GNU screen to be able to use a full featured shell environment."
136            einfo "Just exit the shells (and therefore screen) to continue boot process..."
137            /bin/zsh -c "screen -c /etc/grml/screenrc"
138         else
139            einfo "Notice that the shell does not provide job handling: ctrl-z, bg and fg won't work!"
140            einfo "Just exit the shell to continue boot process..."
141            /bin/zsh
142         fi
143         eoutdent
144      fi
145   fi
146  }
147 }
148 # }}}
149
150 # {{{ log
151 config_log(){
152 if checkbootparam "log" || checkbootparam "debug" ; then
153    export DEBUG="/tmp/grml.log.`date +%Y%m%d`"
154    touch $DEBUG
155    einfo "Bootparameter log found. Log files: ${DEBUG} and /var/log/boot"
156    eindent
157      einfo "Starting bootlogd." # known to be *very* unreliable :(
158      bootlogd -r -c 1>>$DEBUG 2>&1 ; eend $?
159    eoutdent
160 else
161    DEBUG="/dev/null"
162 fi
163 }
164 # }}}
165
166 # {{{ set firmware timeout via bootparam
167 config_fwtimeout(){
168  if checkbootparam fwtimeout ; then
169    TIMEOUT="$(getbootparam 'fwtimeout' 2>>$DEBUG)"
170    einfo "Bootoption fwtimeout found. (Re)Loading firmware_class module."
171    rmmod firmware_class 1>>$DEBUG 2>&1
172    modprobe firmware_class ; eend $?
173  fi
174  if [ -z "$TIMEOUT" ] ; then
175    TIMEOUT="100" # linux kernel default: 10
176  fi
177  if [ -f /sys/class/firmware/timeout ] ; then
178    einfo "Setting timeout for firmware loading to ${TIMEOUT}."
179    echo 100 > /sys/class/firmware/timeout ; eend $?
180  fi
181 }
182 # }}}
183
184 ### {{{ language configuration / localization
185 config_language(){
186
187  einfo "Activating language settings:"
188  eindent
189
190  # people can specify $LANGUAGE and $CONSOLEFONT in a config file:
191  [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
192
193  grep -q ' lang=.*-utf8' /proc/cmdline && UTF8='yes' || UTF8=''
194
195  # check for bootoption which overrides config from /etc/grml/autoconfig:
196  BOOT_LANGUAGE="$(getbootparam lang 2>>$DEBUG)"
197  [ -n "$BOOT_LANGUAGE" ] && LANGUAGE="$BOOT_LANGUAGE"
198
199  # set default to 'en' in live-cd mode if $LANGUAGE is not yet set:
200  if [ -z "$INSTALLED" ] ; then
201     [ -n "$LANGUAGE" ] || LANGUAGE='en-utf8'
202  fi
203
204  # if bootoption lang is used update /etc/default/locale, otherwise *not*!
205  if [ -n "$BOOT_LANGUAGE" ] ; then
206     [ -x /usr/sbin/grml-setlang ] && /usr/sbin/grml-setlang "$LANGUAGE"
207  fi
208
209  # set console font
210  if [ -z "$CONSOLEFONT" ] ; then
211     if ! checkbootparam "nodefaultfont" >>$DEBUG 2>&1 ; then
212        # [ -n "$UTF8" ] && CONSOLEFONT='LatArCyrHeb-16' || CONSOLEFONT='Lat15-Terminus16'
213        # if [ -r /usr/share/consolefonts/Lat15-Terminus16.psf.gz ] ; then
214        if [ -r /usr/share/consolefonts/Uni3-Terminus16.psf.gz ] ; then
215           CONSOLEFONT='Uni3-Terminus16'
216        else
217           ewarn "/usr/share/consolefonts/Uni3-Terminus16.psf.gz not available. Please upgrade package console-terminus." ; eend 1
218        fi
219     fi
220  fi
221
222  # export it now, so error messages get translated, too
223  if checkgrmlsmall ; then
224     export LANG='C' # grml-small does not provide any further locales
225  else
226     [ -r /etc/default/locale ] && . /etc/default/locale
227     export LANG LANGUAGE
228  fi
229
230  # configure keyboard layout, read in already set values first:
231  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
232
233  # now allow keyboard override by boot commandline for later use:
234  KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
235  [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
236  # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
237  [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
238  [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
239
240  # modify /etc/sysconfig/keyboard only in live-cd mode:
241  if [ -z "$INSTALLED" ] ; then
242
243    local LANGUAGE="$BOOT_LANGUAGE"
244    . /etc/grml/language-functions
245    # allow setting xkeyboard explicitly different than console keyboard
246    KXKEYBOARD="$(getbootparam xkeyboard 2>>$DEBUG)"
247    if [ -n "$KXKEYBOARD" ]; then
248       XKEYBOARD="$KXKEYBOARD"
249       KDEKEYBOARD="$KXKEYBOARD"
250    elif [ -n "$KKEYBOARD" ]; then
251       XKEYBOARD="$KKEYBOARD"
252       KDEKEYBOARD="$KKEYBOARD"
253    fi
254
255    # duplicate of previous code to make sure /etc/grml/language-functions
256    # does not overwrite our values....
257    # now allow keyboard override by boot commandline for later use:
258    KKEYBOARD="$(getbootparam keyboard 2>>$DEBUG)"
259    [ -n "$KKEYBOARD" ] && KEYTABLE="$KKEYBOARD"
260    # notce: de/at is a bad choice, so take de-latin1-nodeadkeys instead:
261    [[ "$KKEYBOARD" == 'de' ]] && KEYTABLE=de-latin1-nodeadkeys
262    [[ "$KKEYBOARD" == 'at' ]] && KEYTABLE=de-latin1-nodeadkeys
263
264    # write keyboard related variables to file for later use
265    [ -d /etc/sysconfig ] || mkdir /etc/sysconfig
266    if ! [ -e /etc/sysconfig/keyboard ] ; then
267       echo "KEYTABLE=\"$KEYTABLE\""          > /etc/sysconfig/keyboard
268       echo "XKEYBOARD=\"$XKEYBOARD\""       >> /etc/sysconfig/keyboard
269       echo "KDEKEYBOARD=\"$KDEKEYBOARD\""   >> /etc/sysconfig/keyboard
270       echo "KDEKEYBOARDS=\"$KDEKEYBOARDS\"" >> /etc/sysconfig/keyboard
271    fi
272  fi
273
274  [ -r /etc/sysconfig/keyboard ] && . /etc/sysconfig/keyboard
275
276  # activate unicode console if running within utf8 environment
277  if [ -r /etc/default/locale ] ; then
278     if grep -q "LANG=.*UTF" /etc/default/locale ; then
279        einfo "Setting up unicode environment."
280        unicode_start 2>>$DEBUG ; eend $?
281     fi
282  fi
283
284  # Set default keyboard before interactive setup
285  if [ -n "$KEYTABLE" ] ; then
286     einfo "Running loadkeys for ${WHITE}${KEYTABLE}${NORMAL} in background"
287     loadkeys -q $KEYTABLE &
288     eend $?
289  fi
290
291  # we have to set up all consoles, therefore loop it over all ttys:
292  NUM_CONSOLES=$(fgconsole --next-available)
293  NUM_CONSOLES=$(expr ${NUM_CONSOLES} - 1)
294  [ ${NUM_CONSOLES} -eq 1 ] && NUM_CONSOLES=6
295  CUR_CONSOLE=$(fgconsole)
296
297  if [ -n "$CHARMAP" ] ; then
298     einfo "Running consolechars for ${CHARMAP}"
299     for vc in `seq 0 ${NUM_CONSOLES}`  ; do
300         consolechars --tty=/dev/tty${vc} -m ${CHARMAP} ; RC=$?
301     done
302     [ -n "$CUR_CONSOLE" ] && chvt $CUR_CONSOLE
303     eend $RC
304  fi
305
306  if checkbootparam noconsolefont ; then
307     ewarn "Skipping setting console font as requested on boot commandline." ; eend 0
308  else
309     if [ -n "$CONSOLEFONT" ] ; then
310        einfo "Running consolechars using ${CONSOLEFONT}"
311        for vc in `seq 0 ${NUM_CONSOLES}`  ; do
312            consolechars --tty=/dev/tty${vc} -f $CONSOLEFONT ; RC=$?
313        done
314        [ -n "$CUR_CONSOLE" ] && chvt $CUR_CONSOLE
315        eend $?
316     fi
317  fi
318
319  eoutdent
320 }
321 # }}}
322
323 # {{{ Set hostname
324 config_hostname(){
325  if checkbootparam hostname ; then
326   HOSTNAME="$(getbootparam 'hostname' 2>>$DEBUG)"
327   einfo "Setting hostname to $HOSTNAME as requested."
328   sed -i "s/^127.0.0.1.*localhost/127.0.0.1 $HOSTNAME localhost/" /etc/hosts
329   hostname $HOSTNAME ; eend $?
330  else
331   hostname --file /etc/hostname
332  fi
333 }
334 # }}}
335
336 # fstabuser (needed when running from harddisk with username != grml {{{
337 config_userfstab(){
338   [ -r /etc/grml/autoconfig ] && . /etc/grml/autoconfig
339   if [ -n "$CONFIG_FSTAB_USER" ] ; then
340      fstabuser="$CONFIG_FSTAB_USER"
341   else
342      fstabuser=$(getent passwd 1000 | cut -d: -f1)
343   fi
344   # if not yet set fall back to default 'grml' user
345   [ -n "$fstabuser" ] || fstabuser='grml'
346 }
347 # }}}
348
349 # {{{ Set clock (Local time is more often used than GMT, so it is default)
350 config_time(){
351  # don't touch the files if running from harddisk:
352  if [ -z "$INSTALLED" ]; then
353     UTC=""
354     checkbootparam utc >>$DEBUG 2>&1 && UTC="-u"
355     checkbootparam gmt >>$DEBUG 2>&1 && UTC="-u"
356     # hwclock uses the TZ variable
357     [ -r /etc/timezone ] && TZ=$(cat /etc/timezone)
358     [ -n "$TZ" ] || TZ=Europe/Vienna
359
360     if ! [ -r /dev/rtc ] ; then
361       ewarn "Realtime clock not available, skipping execution of hwclock therefore." ; eend 0
362     else
363       ERROR=$(TZ="$TZ" hwclock $UTC -s 2>&1 | head -1) ; RC=$?
364       if [ -n "$ERROR" ] ; then
365          eindent
366          ERROR=$(TZ="$TZ" hwclock $UTC -s --directisa 2>&1 | head -1)
367          if [ -n "$ERROR" ] ; then
368             eerror "Problem running hwclock: $ERROR" ; eend 1
369          fi
370          eoutdent
371       fi
372     fi
373  fi
374 }
375 # }}}
376
377 # {{{ print kernel info
378 config_kernel(){
379   vmware-detect &>/dev/null && VMWARE="inside ${WHITE}VMware/Qemu${NORMAL}"
380   [ -d /proc/xen ] && VMWARE='' # vmware-detect returns '0' when running with a Xen-enabled kernel
381   einfo "Running Linux Kernel $KERNEL $VMWARE" ; eend 0
382   if [ -r /proc/cpuinfo ] ; then
383      if egrep -q '^flags.*(vmx|svm)' /proc/cpuinfo ; then
384        eindent
385        einfo 'CPU(s) featuring virtualization technology detected' ; eend 0
386        eoutdent
387      fi
388   fi
389   if [ -d /proc/xen ] ; then
390      eindent
391      einfo 'Running kernel featuring support for Xen detected' ; eend 0
392      eoutdent
393   fi
394 }
395 # }}}
396
397 # {{{ vmware specific stuff
398 config_vmware(){
399 if checkbootparam novmware ; then
400    ewarn "Skipping running vmware specific stuff as requested on boot commandline." ; eend 0
401 else
402    if [ -z "$INSTALLED" ] ; then
403       if vmware-detect || stringinstring "BOOT_IMAGE=vmware " "$CMDLINE" ; then
404          if ! checkbootparam qemu ; then
405             if [ -r /etc/X11/xorg.conf.vmware ] ; then
406                einfo "VMware: Copying /etc/X11/xorg.conf.vmware to /etc/X11/xorg.conf"
407                cp /etc/X11/xorg.conf.vmware /etc/X11/xorg.conf ; eend $?
408             fi
409          fi
410       elif [ -r /proc/acpi/battery/BAT0/info -a -r /etc/X11/xorg.conf.virtualbox ] ; then
411          if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
412             einfo 'Virtual Box: Copying /etc/X11/xorg.conf.virtualbox to /etc/X11/xorg.conf'
413             cp /etc/X11/xorg.conf.virtualbox /etc/X11/xorg.conf ; eend $?
414          fi
415       fi
416    fi
417 fi
418 }
419 # }}}
420
421 # {{{ qemu specific stuff
422 config_qemu(){
423 if checkbootparam qemu ; then
424    if [ -r /etc/X11/xorg.conf.example ] ; then
425       einfo "Qemu: Copying /etc/X11/xorg.conf.example to /etc/X11/xorg.conf"
426       cp /etc/X11/xorg.conf.example /etc/X11/xorg.conf ; eend $?
427    fi
428 fi
429 }
430 # }}}
431
432 # {{{ ld.so.cache + depmod
433 config_ld_mod(){
434 if [ -n "$INSTALLED" ]; then
435  if ! [ -r /etc/grml.first.boot ] ; then
436   einfo "Running from HD for the first time, regenerate ld.so.cache and modules.dep:"
437   eindent
438 # Regenerate ld.so.cache and module dependencies on HD
439     einfo "Running ldconfig" ; ldconfig  ; eend $?
440     einfo "Running depmod"   ; depmod -a ; eend $?
441     touch /etc/grml.first.boot
442     eend 0
443   eoutdent
444  fi
445 fi
446 }
447 # }}}
448
449 # {{{ timezone
450 config_timezone(){
451  # don't touch the files if running from harddisk:
452  if [ -z "$INSTALLED" ]; then
453     KTZ="$(getbootparam tz 2>>$DEBUG)"
454     if [ -n "$KTZ" ] ; then
455        einfo "Setting timezone."
456        [ -f "/usr/share/zoneinfo/$KTZ" ] && TZ="$KTZ"
457        rm -f /etc/localtime
458        cp "/usr/share/zoneinfo/$TZ" /etc/localtime ; eend $?
459     fi
460  fi
461 }
462 # }}}
463
464 # small computer / nearly no ram {{{
465 config_small(){
466
467 RAM=$(/usr/bin/gawk '/MemTotal/{print $2}' /proc/meminfo)
468 # MEM=$(/usr/bin/gawk 'BEGIN{m=0};/MemFree|Cached|SwapFree/{m+=$2};END{print m}' /proc/meminfo)
469 eindent
470
471 if checkbootparam "small"; then
472   einfo "Information: ${RAM} kB of RAM available." ; eend 0
473   einfo "Bootoption small detected. Activating small system."
474   if [ -r /etc/inittab.small ] ; then
475     mv /etc/inittab /etc/inittab.normal
476     mv /etc/inittab.small /etc/inittab
477   else
478     sed -i 's/^9/#&/' /etc/inittab
479     sed -i 's/^10/#&/' /etc/inittab
480     sed -i 's/^11/#&/' /etc/inittab
481     sed -i 's/^12/#&/' /etc/inittab
482   fi
483   /sbin/telinit q ; eend $?
484 else
485   if checkgrmlsmall ; then
486     if [[ $RAM -lt 25000 ]] ; then
487       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
488       ewarn "At least 32MB of RAM should be available for grml-small." ; eend 1
489       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
490       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
491       /bin/zsh --login
492     else
493       einfo "Information: ${RAM} kB of RAM available." ; eend 0
494     fi
495   else
496     if [[ $RAM -lt 58000 ]] ; then
497       ewarn "Information: ${RAM} kB of RAM available." ; eend 1
498       ewarn "At least 64MB of RAM should be available for grml." ; eend 1
499       ewarn "Use the bootoption small to save some more MB of memory usage." ; eend 0
500       ewarn "Dropping you into a rescue shell. To continue booting exit the shell." ; eend 0
501       /bin/zsh --login
502     else
503       einfo "Information: ${RAM} kB of RAM available." ; eend 0
504     fi
505   fi
506 fi
507 eoutdent
508 }
509 # }}}
510
511 # skip startup of w3m {{{
512 config_fast(){
513 if checkbootparam "fast"; then
514   ewarn "Bootoption fast detected. Skipping startup of w3m."
515     sed -i 's#^1:.*#1:12345:respawn:/usr/bin/openvt -f -c 1 -w -- /bin/zsh#' /etc/inittab
516   /sbin/telinit q ; eend $?
517 fi
518 }
519 # }}}
520
521 # activate serial console {{{
522 config_console(){
523 if checkbootparam "console"; then
524   einfo "Bootoption (for serial) console detected."
525   eindent
526     if [ -r /etc/mgetty/mgetty.config ] ; then
527        MODE=$(getbootparam console | awk -F, '{print $2}')
528        MODE=${MODE%%n*}
529        [ -n "$MODE" ] || MODE=9600 # default mode
530        einfo "Setting speed in /etc/mgetty/mgetty.config to $MODE bps"
531        sed -i "s/speed [0-9]*/speed $MODE/" /etc/mgetty/mgetty.config ; eend $?
532     fi
533
534     einfo "Activating mgetty."
535     sed -i 's/^#T0/T0/' /etc/inittab
536     sed -i 's/^#T1/T1/' /etc/inittab
537     /sbin/telinit q ; eend $?
538   eoutdent
539 fi
540 }
541 # }}}
542
543 # For burning on IDE-CD-Roms, k3b (and others) check for special permissions {{{
544 config_cdrom_perm(){
545 CDROMS=""
546 for DEVICE in /proc/ide/hd?; do
547  [ "$(cat $DEVICE/media 2>/dev/null)" = "cdrom" ] && CDROMS="$CDROMS /dev/${DEVICE##*/}"
548 done
549 [ -n "$CDROMS" ] && { chown root.cdrom $CDROMS; chmod 666 $CDROMS; } 2>/dev/null
550 }
551 # }}}
552
553 # {{{ Bring up loopback interface now
554 config_local_net(){
555  if [ -z "$INSTALLED" ] ; then
556     if grep -q 'iface lo inet loopback' /etc/network/interfaces 2>/dev/null ; then
557        grep -q lo=lo /etc/network/run/ifstate 2>/dev/null || ifup lo
558     else
559        ifconfig lo up
560     fi
561  fi
562 }
563 # }}}
564
565 # firewire devices {{{
566 # the raw1394 driver does not yet export info into SYSFS,
567 # so let's create raw1394 device manually
568 # http://www.michael-prokop.at/blog/index.php?p=352
569 config_firewire_dev(){
570 if checkbootparam "nofirewiredev" ; then
571   ewarn "Skipping creating some firewire devices as requested on boot commandline." ; eend 0
572 else
573 #if [ "${KERNEL%-*}" == "2.6.11" ] ; then
574   einfo "Creating some firewire devices (fix kernel 2.6-bug)."
575 #  cd /dev && MAKEDEV video1394 raw1394
576   [ -r /dev/raw1394 ]   || mknod /dev/raw1394 c 171 0
577   [ -r /dev/video1394 ] || mknod -m 666 /dev/video1394 c 171 16
578 # mknod -m 666 /dev/dv1394 c 171 32 # for NTSC
579   [ -r /dev/dv1394 ]    || mknod -m 666 /dev/dv1394 c 171 34 # for PAL
580   chown -R root:video /dev/raw1394 /dev/video1394 /dev/dv1394
581   chmod -R 664 /dev/raw1394 /dev/video1394 /dev/dv1394 ; eend $?
582 fi
583 #fi
584 }
585 # }}}
586
587 # {{{ copy passwd-lockfile to ramdisk (fix unionfs-behaviour)
588 # otherwise we will get: passwd: Authentication token lock busy
589 config_fix_passwd(){
590  if [ -z "$INSTALLED" ] ; then
591   touch /etc/.pwd.lock
592  fi
593 }
594 # }}}
595
596 # {{{ CD Checker
597 config_testcd(){
598 if [ -n "$TESTCD" ]; then
599    einfo "Checking CD data integrity as requested by '${WHITE}testcd${NORMAL}' boot option."
600    einfo "Reading files and checking against GRML/md5sums, this may take a while..."
601    echo -n "${RED}"
602
603    if [ -n "${LIVECD_PATH}"/GRML ] ; then
604       ( cd "${LIVECD_PATH}"/GRML ; rm -f /tmp/md5sum.log ; md5sum -c md5sums 2>&1 | tee /tmp/md5sum.log ; RC=$? )
605    else
606       echo "${RED} *** Error: Could not find md5sum file.                           ***"
607    fi
608
609    if [ "$RC" = "0" ]; then
610       einfo "Everything looks OK" ; eend 0
611    else
612       eerror 'Checksum failed for theses files:' ; eend 1
613       egrep -v '(^md5sum:|OK$)' /tmp/md5sum.log
614       eerror 'Data on the grml medium is possibly incomplete/damaged or...'
615       eerror '... RAM of your computer is broken.' ; eend 1
616       einfon "Hit return to continue, or press the reset button to quit."
617      read a
618    fi
619
620    eend 0
621 fi
622 }
623 # }}}
624
625 # {{{ hardware detection via discover
626 config_discover(){
627 if checkbootparam "nodisc" ; then
628   ewarn "Skipping hardware detection via discover as requested on boot commandline." ; eend 0
629 else
630  if [ -x /sbin/discover ] ; then
631   einfo "Discovering hardware. Trying to load the following modules in background:"
632    eindent
633    einfo "$(discover --data-path=linux/module/name --data-path=linux/modules/options --format="%s %s" --data-version=`uname -r` --enable-bus all | sort -u | xargs echo)"
634    eoutdent
635   /sbin/discover-modprobe -v 1>>$DEBUG 2>&1 &
636   eend 0
637  else
638   eerror "Application discover not available. Information: udev should handle hardware recognition." ; eend 0
639  fi
640 fi
641 }
642 # }}}
643
644 # {{{ hardware detection via hwinfo
645 config_hwinfo(){
646 if checkbootparam hwinfo >>$DEBUG 2>&1; then
647   einfo "Discovering hardware via hwinfo:"
648   MODULES=$(su grml hwinfo | grep "Cmd: \"modprobe" | awk '{print $5}' | sed 's/"//')
649   echo -n "  Loading modules: "
650   for i in `echo $MODULES` ; do echo -n $i && modprobe $i ; done
651   eend 0
652 fi
653 }
654 # }}}
655
656 # {{{ disable hotplug agents on request
657 config_hotplug_agent(){
658 if checkbootparam "noagent" ; then
659   AGENT="$(getbootparam 'noagent' 2>>$DEBUG)"
660   AGENTLIST=$(echo "$AGENT" | sed 's/,/\\n/g')
661   AGENTNL=$(echo "$AGENT" | sed 's/,/ /g')
662   einfo "Disabling hotplug-agent(s) $AGENTNL"
663   for agent in $(echo -e $AGENTLIST) ; do
664     mv /etc/hotplug/${agent}.rc /etc/hotplug/${agent}.norc
665   done
666   [ "$?" == "0" ] ; eend $?
667 fi
668 }
669 # }}}
670
671 # {{{ blacklist of hotplug-modules
672 config_hotplug_blacklist(){
673 if checkbootparam "black" ; then
674   BLACK="$(getbootparam 'black' 2>>$DEBUG)"
675   BLACKLIST=$(echo "$BLACK" | sed 's/,/\\n/g')
676   BLACKNL=$(echo "$BLACK" | sed 's/,/ /g')
677   einfo "Blacklisting $BLACKNL via /etc/hotplug/blacklist.d/hotplug-light"
678   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist.d/hotplug-light
679   echo -e "$BLACKLIST" >> /etc/hotplug/blacklist
680   eend 0
681 fi
682 }
683 # }}}
684
685 # {{{ run hotplug
686 config_hotplug(){
687 if checkbootparam "nohotplug" ; then
688   ewarn "Skipping running hotplug as requested on boot commandline." ; eend 0
689 else
690   if [ -r /etc/init.d/hotplug ] ; then
691     einfo "Starting hotplug system in background."
692     /etc/init.d/hotplug start 1>>$DEBUG 2>>$DEBUG &
693     eend 0
694   elif [ -r /etc/init.d/hotplug-light ] ; then
695     einfo "Starting hotplug-light system in background."
696     /etc/init.d/hotplug-light start 1>>$DEBUG 2>>$DEBUG &
697     eend 0
698   else
699     ewarn "No hotplug system found. Should be handled by udev. Skipping execution." ; eend 0
700   fi
701 fi
702 }
703 # }}}
704
705 # {{{ blacklist specific module [ used in /etc/init.d/udev ]
706 config_blacklist(){
707 if checkbootparam "blacklist" ; then
708  if [ -z "$INSTALLED" ]; then
709   einfo "Bootoption blacklist found."
710   BLACK="$(getbootparam 'blacklist' 2>>$DEBUG)"
711   if [ -n "$BLACK" ] ; then
712     for module in $(echo ${BLACK//,/ }) ; do
713         einfo "Blacklisting module ${module} via /etc/modprobe.d/grml."
714         echo "# begin entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml
715         echo "blacklist $module"     >> /etc/modprobe.d/grml
716         echo "alias     $module off" >> /etc/modprobe.d/grml
717         echo "# end   entry generated by config_blacklist of grml-autoconfig" >> /etc/modprobe.d/grml ; eend $?
718     done
719   else
720    eerror "No given module for blacklist found. Blacklisting will not work therefore."
721   fi
722  else
723   ewarn "Backlisting via bootoption is not intended for use on harddisk installations." ; eend 1
724   eindent
725    einfo "Please blacklist the module(s) manually using the 'blacklist' script."
726   eoutdent
727  fi
728 fi
729 }
730 # }}}
731
732 # {{{ ACPI
733 config_acpi_apm(){
734 if [ -d /proc/acpi ]; then
735   if checkbootparam "noacpi"; then
736     ewarn "Skipping ACPI Bios detection as requested via noacpi on boot commandline." ; eend 0
737   elif checkbootparam "nogrmlacpi" ; then
738     ewarn "Skipping ACPI Bios detection as requested via nogrmlacpi on boot commandline." ; eend 0
739   else
740     einfo "ACPI Bios found, activating modules (disable via bootoption noacpi / nogrmlacpi): "
741     eindent
742     found=""
743     for a in /lib/modules/$KERNEL/kernel/drivers/acpi/*; do
744       basename="${a##*/}"
745       basename="${basename%%.*}"
746       case "$basename" in *_acpi)
747        egrep -qi "${basename%%_acpi}" /proc/acpi/dsdt 2>>$DEBUG || continue ;;
748       esac
749       modprobe $basename >>$DEBUG 2>&1 && found="yes"
750       local BASE="$BASE $basename"
751     done
752     if [ -n "$found" ] ; then
753       einfo "$BASE"  ; eend 0
754     else
755       ewarn "(none)" ; eend 1
756     fi
757     if ! ps x | grep -q /usr/sbin/acpid ; then
758       if ! [ -r /var/run/dbus/pid ] ; then
759         einfo "Starting acpi daemon."
760         /etc/init.d/acpid start 1>>$DEBUG 2>&1 ; eend $?
761       else
762         eerror "acpid error: it seems you are running d-bus/hal, but acpid needs to be started before d-bus."
763         eerror "Solution: please activate acpid via /etc/runlevel.conf"
764         eend 1
765       fi
766     else
767       ewarn "acpi daemon already running."
768       eend 0
769     fi
770     eoutdent
771   fi
772 else
773 # APM
774   if checkbootparam "noapm"; then
775     ewarn "Skipping APM Bios detection as requested on boot commandline." ; eend 0
776   else
777     modprobe apm power_off=1 >>$DEBUG 2>&1
778     if [ "$?" = "0" ] ; then
779        if [ -x /etc/init.d/apmd ] ;then
780           einfo "APM Bios found, enabling power management functions."
781           /etc/init.d/apmd start ; eend $?
782        fi
783     else
784       eerror "Loading apm module failed." ; eend 1
785     fi
786   fi
787 fi
788 }
789 # }}}
790
791 # {{{ PCMCIA Check/Setup
792 # This needs to be done before other modules are being loaded (by hwsetup)
793 config_pcmcia(){
794 if checkbootparam "nopcmcia"; then
795   ewarn "Skipping PCMCIA detection as requested on boot commandline." ; eend 0
796 else
797   if /usr/sbin/laptop-detect ; then
798     einfo "Detected Laptop - checking for PCMCIA." && eend 0
799     modprobe pcmcia_core >>$DEBUG 2>&1
800     # Try Cardbus or normal PCMCIA socket drivers
801     modprobe yenta_socket >>$DEBUG 2>&1 || modprobe i82365 >>$DEBUG 2>&1 || modprobe pd6729 >>$DEBUG 2>&1 || modprobe tcic >>$DEBUG 2>&1
802     if [ "$?" = "0" ]; then
803       modprobe ds >>$DEBUG 2>&1
804       if [ -d /proc/bus/pccard ] ; then
805        if [ -x /sbin/cardmgr ] ; then
806         einfo "PCMCIA found, starting cardmgr."
807         cardmgr >>$DEBUG 2>&1 && sleep 6 && eend 0
808        else
809         eerror "No cardmgr found. Make sure package pcmciautils is installed, it should handle it instead." ; eend 1
810        fi
811       fi
812     fi
813   fi
814 fi
815 }
816 # }}}
817
818 # {{{ run software synthesizer via speakup
819 config_swspeak(){
820 if checkbootparam swspeak ; then
821  if [ -d /proc/speakup/ ] ; then
822   einfo "Bootoption swspeak found. Kernel supports speakup." ; eend 0
823   eindent
824    if [ -x /etc/init.d/speech-dispatcher ] ; then
825      einfo "Starting speech-dispatcher."
826      /etc/init.d/speech-dispatcher start 1>>DEBUG ; eend $?
827      einfo "Activating sftsyn in Kernel."
828      echo sftsyn >/proc/speakup/synth_name ; eend $?
829      einfo "Just run swspeak if you want to use software synthesizer via speakup."
830      flite -o play -t "Finished activating software speakup. Just run swspeak when booting finished."
831    else
832     eerror "speech-dispatcher not available. swspeak will not work without it." ; eend 1
833     flite -o play -t "speech-dispatcher not available. speakup will not work without it."
834    fi
835   eoutdent
836  else
837   eerror "Kernel does not seem to support speakup. Skipping swspeak." ; eend 1
838   flite -o play -t "Kernel does not seem to support speakup. Sorry."
839  fi
840 fi
841 }
842 # }}}
843
844 # {{{ Check for blind option or brltty
845 config_blind(){
846 BLIND=""
847 checkbootparam "blind" && BLIND="yes"
848 BRLTTY="$(getbootparam brltty 2>>$DEBUG)"
849
850 if [ -n "$BLIND" -o -n "$BRLTTY" ]; then
851   if [ -x /sbin/brltty ]; then
852     # Blind option detected, start brltty now.
853     # modprobe serial_core parport_serial generic_serial && echo "done"
854     CMD=brltty
855     BRLTYPE=""
856     BRLDEV=""
857     BRLTEXT=""
858     if [ -n "$BRLTTY" ]; then
859       # Extra options
860       BRLTYPE="${BRLTTY%%,*}"
861       R="${BRLTTY#*,}"
862       if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
863         BRLTTY="$R"
864         BRLDEV="${BRLTTY%%,*}"
865         R="${BRLTTY#*,}"
866         if [ -n "$R" -a "$R" != "$BRLTTY" ]; then
867           BRLTTY="$R"
868           BRLTEXT="${BRLTTY%%,*}"
869           R="${BRLTTY#*,}"
870         fi
871       fi
872     fi
873     [ -n "$BRLTYPE" ] && CMD="$CMD -b $BRLTYPE"
874     [ -n "$BRLDEV"  ] && CMD="$CMD -d $BRLDEV"
875     [ -n "$BRLTEXT" ] && CMD="$CMD -t $BRLTEXT"
876     einfo "Starting braille-display manager."
877 #    ( exec $CMD & )
878     ( sh -c "$CMD" & )
879     sleep 2 && BLINDSOUND="yes"
880     eend 0
881   fi
882 fi
883 }
884 # }}}
885
886 # {{{ Interactive configuration
887 config_interactive(){
888   ewarn "config_interactive is deprecated nowadays."
889   ewarn "Please set CONFIG_INTERACTIVE='no' in /etc/grml/autoconfig" ; eend 0
890 }
891 # }}}
892
893 # {{{ AGP
894 config_agp(){
895 if checkbootparam forceagp ; then
896 # Probe for AGP. Hope this can fail safely
897   stringinfile "AGP" "/proc/pci" 2>>$DEBUG && { modprobe agpgart || modprobe agpgart agp_try_unsupported=1; } >>$DEBUG 2>&1 && einfo "AGP bridge detected." ; eend 0
898 fi
899 }
900 # }}}
901
902 # {{{ automount(er)
903 config_automounter(){
904 if checkbootparam automounter ; then
905   RUNLEVEL="$(runlevel)"
906   AUTOMOUNTER=""
907   [ -x /etc/init.d/autofs ] && [ "$RUNLEVEL" != "N 1" ] && [ "$RUNLEVEL" != "N S" ] && AUTOMOUNTER="yes"
908
909 addautomount(){
910 # /dev/ice  options
911   d="${1##*/}"
912   if [ -n "$AUTOMOUNTER" ]; then
913     [ -d "/mnt/$d" -a ! -L "/mnt/$d" ] && rmdir /mnt/$d
914     [ -d "/mnt/auto/$d" ] || mkdir -p "/mnt/auto/$d"
915     [ -L "/mnt/$d" ]      || ln -s "/mnt/auto/$d" "/mnt/$d"
916     anew="$d        -fstype=auto,$2 :$i"
917     stringinfile "$anew" "/etc/auto.mnt" || echo "$anew" >> /etc/auto.mnt
918     AUTOMOUNTS="$AUTOMOUNTS $d"
919     new="$1 /mnt/auto/$d  auto   users,noauto,exec,$2 0 0"
920   else
921     [ -d /mnt/$d ] && mkdir -p /mnt/$d
922     new="$1 /mnt/$d  auto   users,noauto,exec,$2 0 0"
923   fi
924   stringinfile "$new" "/etc/fstab" || echo "$new" >> /etc/fstab
925 }
926
927   AUTOMOUNTS="floppy cdrom"
928 # Add new devices to /etc/fstab and /etc/auto.mnt
929   for i in /dev/cdrom?*; do
930     if [ -L $i ]; then
931       addautomount "$i" "ro"
932     fi
933   done
934 fi
935
936 if [ -n "$AUTOMOUNTER" ]; then
937 # Check for floppy dir, reinstall with automounter
938   [ -d /mnt/floppy -a ! -L /mnt/floppy ] && rmdir /mnt/floppy
939   [ -d /mnt/auto/floppy ] || mkdir -p /mnt/auto/floppy
940   [ -L /mnt/floppy ] || ln -s /mnt/auto/floppy /mnt/floppy
941   [ -d /mnt/cdrom -a ! -L /mnt/cdrom ] && rmdir /mnt/cdrom
942   [ -d /mnt/auto/cdrom ] || mkdir -p /mnt/auto/cdrom
943   [ -L /mnt/cdrom ] || ln -s /mnt/auto/cdrom /mnt/cdrom
944   rm -f /etc/fstab.new
945 # Replace paths from bootfloppy
946   sed 's|/mnt/cdrom|/mnt/auto/cdrom|g;s|/mnt/floppy|/mnt/auto/floppy|g' /etc/fstab > /etc/fstab.new
947   mv -f /etc/fstab.new /etc/fstab
948 # Start automounter now
949   einfo "Starting automounter for ${AUTOMOUNTS}."
950   /etc/init.d/autofs start >>$DEBUG ; eend $?
951 fi
952 }
953 # }}}
954
955 # {{{ Collect partitions from /proc/partitions first for enabling DMA
956 check_partitions(){
957 partitions=""
958 IDEDISKS=""
959 while read major minor blocks partition relax; do
960   partition="${partition##*/}"
961   [ -z "$partition" -o ! -e "/dev/$partition" ] && continue
962   case "$partition" in
963     hd?) IDEDISKS="$IDEDISKS $partition";;                # IDE  Harddisk, entire disk
964     sd?) ;;                                               # SCSI Harddisk, entire disk
965 #    [hs]d*) partitions="$partitions /dev/$partition";;    # IDE or SCSI disk partition
966     [hs]d*|ub*) partitions="$partitions /dev/$partition";;    # IDE, USB or SCSI disk partition
967   esac
968 done <<EOT
969 $(awk 'BEGIN{old="__start"}{if($0==old){exit}else{old=$0;if($4&&$4!="name"){print $0}}}' /proc/partitions)
970 EOT
971 }
972 check_partitions 1>/dev/null 2>&1 # avoid output "check_partitions:3: read-only file system"
973 # }}}
974
975 # {{{ Enable DMA for all IDE drives now if not disabled
976 # Notice: Already done by linuxrc, but make sure it's done also on harddisk-installed systems
977 config_dma(){
978 if checkbootparam "nodma"; then
979   ewarn "Skipping DMA accelleration as requested on boot commandline." ; eend 0
980 else
981   for d in $(cd /proc/ide 2>>$DEBUG && echo hd[a-z]); do
982     if test -d /proc/ide/$d; then
983       if egrep -q 'using_dma[ \t]+0' /proc/ide/$d/settings 2>>$DEBUG; then
984         MODEL="$(cat /proc/ide/$d/model 2>>$DEBUG)"
985         test -z "$MODEL" && MODEL="[GENERIC IDE DEVICE]"
986         einfo "Enabling DMA acceleration for: ${WHITE}$d        ${YELLOW}[${MODEL}]${NORMAL}"
987         echo "using_dma:1" >/proc/ide/$d/settings
988         eend 0
989       fi
990     fi
991   done
992 fi
993 }
994 # }}}
995
996 # {{{ Start creating /etc/fstab with HD partitions and USB SCSI devices now
997 config_fstab(){
998
999 NOSWAP="yes" # we do not use swap by default!
1000 if checkbootparam "swap" || checkbootparam "anyswap" ; then
1001    NOSWAP=''
1002    checkbootparam "anyswap" && export ANYSWAP='yes' || export ANYSWAP=""
1003 fi
1004
1005 if checkbootparam "nofstab" || checkbootparam "forensic" ; then
1006   ewarn "Skipping /etc/fstab creation as requested on boot commandline." ; eend 0
1007 else
1008   einfo "Scanning for harddisk partitions and creating /etc/fstab. (Disable this via boot option: nofstab)"
1009   iszsh && setopt nonomatch
1010   if [ -x /usr/sbin/rebuildfstab ] ; then
1011      config_userfstab || fstabuser=grml
1012      /usr/sbin/rebuildfstab -r -u $fstabuser -g $fstabuser ; eend $?
1013   else
1014      ewarn "Command rebuildfstab not found. Install package grml-rebuildfstab." ; eend 1
1015   fi
1016 fi # checkbootparam nofstab/forensic
1017
1018 # Scan for swap, config, homedir - but only in live-mode
1019 if [ -z "$INSTALLED" ] ; then
1020    [ -z "$NOSWAP" ] && einfo "Searching for swap partition(s) as requested."
1021    GRML_IMG=""
1022    GRML_SWP=""
1023    HOMEDIR="$(getbootparam home)"
1024    if [ -n "$partitions" ]; then
1025       while read p m f relax; do
1026         case "$p" in *fd0*|*proc*|*sys*|*\#*) continue;; esac
1027         partoptions="users,exec"
1028         fnew=""
1029         # it's a swap partition?
1030         case "$f" in swap)
1031           eindent
1032           if [ -n "$NOSWAP" ]; then
1033              ewarn "Ignoring swap partition ${WHITE}$p${NORMAL}. (Force usage via boot option 'swap', or execute grml-swapon)"
1034              eend 0
1035           else
1036              case "$(dd if=$p bs=1 count=6 skip=4086 2>/dev/null)" in
1037                    S1SUSP|S2SUSP|pmdisk|[zZ]*)
1038                      if [ -n "$ANYSWAP" ] ; then
1039                         einfo "Using swap partition ${WHITE}${p}${NORMAL} [bootoption anyswap found]."
1040                         swapon $p 2>>$DEBUG ; eend $?
1041                      else
1042                         ewarn "Suspend signature on ${WHITE}${p}${NORMAL} found, not using as swap. (Force usage via boot option: anyswap)"
1043                      fi
1044                      ;;
1045                    *)
1046                      if [[ "$p" == LABEL* ]] ; then
1047                         p=$(blkid -t $p | awk -F: '{print $1}')
1048                      fi
1049                      if grep -q $p /proc/swaps ; then
1050                         ewarn "Not using swap partition ${WHITE}${p}${NORMAL} as it is already in use." ; eend 0
1051                      else
1052                         if [ -b "$p" ] ; then
1053                         einfo "Using swap partition ${WHITE}${p}${NORMAL}."
1054                         swapon $p 2>>$DEBUG ; eend $?
1055                         else
1056                         ewarn "$p is not a valid block device - not using it therefore." ; eend 0
1057                         fi
1058                      fi
1059                      ;;
1060              esac # dd-check
1061           fi # -n "$NOSWAP
1062           eoutdent
1063           continue
1064           ;;
1065         esac # it's a swap partition?
1066
1067         # mount read-only
1068         MOUNTOPTS="ro"
1069         case "$f" in
1070           vfat|msdos|ntfs) MOUNTOPTS="$MOUNTOPTS,uid=${fstabuser},gid=${fstabuser}" ;;
1071           ext2|ext3|reiserfs|jfs|reiser4|xfs) MOUNTOPTS="$MOUNTOPTS,noatime" ;;
1072           *) continue ;;
1073           # *) NONEFOUND='1'; continue ;;
1074         esac
1075
1076         # use a swapfile
1077         if [ -z "$NOSWAP" ] ; then
1078            mount -o "$MOUNTOPTS" -t $f $p $m 2>>$DEBUG && MOUNTED=1 || continue
1079            # Activate swapfile, if exists
1080            SWAPFILE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ss][Ww][Pp] 2>/dev/null)"
1081         fi
1082         if [ -z "$NOSWAP" -a -n "$SWAPFILE" -a -f "$SWAPFILE" ]; then
1083            mount -o remount,rw $m && MOUNTED=1
1084            if swapon "$SWAPFILE" 2>>$DEBUG ; then
1085               eindent
1086                 einfo "Using GRML swapfile ${WHITE}${SWAPFILE}${NORMAL}."
1087               eoutdent
1088               fnew="$SWAPFILE swap swap defaults 0 0"
1089               stringinfile "$fnew" "/etc/fstab" || echo "$fnew" >> /etc/fstab
1090               GRML_SWP="$GRML_SWP $SWAPFILE"
1091               eend 0
1092            fi
1093            mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1094         fi
1095
1096         # use a image as home
1097         IMAGE="$(/bin/ls -1d $m/[Gg][Rr][Mm][Ll].[Ii][Mm][Gg] 2>/dev/null)"
1098         if [ -z "$GRML_IMG" -a -n "$IMAGE" -a -f "$IMAGE" ]; then
1099            if [ -n "$HOMEDIR" ]; then
1100               if [ "$HOMEDIR" != "scan" -a "$HOMEDIR" != "$IMAGE" -a "$HOMEDIR" != "${IMAGE%/*.*}" ]; then
1101                  continue
1102               fi
1103            fi
1104            if type -a grml-image >/dev/null 2>&1 && grml-image "$IMAGE" </dev/console >/dev/console 2>&1; then
1105               GRML_IMG="$IMAGE"
1106               mount -o remount,ro $m 2>>$DEBUG && MOUNTED=1
1107            fi
1108         fi
1109         eend 0
1110
1111         # Umount, if not in use
1112         [ -n "$MOUNTED" ] && umount -r $m 2>/dev/null
1113
1114       done <<EOT
1115       $(cat /etc/fstab)
1116 EOT
1117    fi # -n $partitions
1118 fi # -z $INSTALLED
1119 }
1120 # }}}
1121
1122 # {{{ Mouse
1123 config_mouse(){
1124 if [ -n "$MOUSE_DEVICE" ] ; then
1125   einfo "Detecting mouse: ${MOUSE_FULLNAME} at ${MOUSE_DEVICE}" ; eend $?
1126 fi
1127 }
1128 # }}}
1129
1130 # {{{ IPv6 configuration
1131 # Load IPv6 kernel module and print IP adresses
1132 config_ipv6(){
1133 if checkbootparam "ipv6"; then
1134   einfo "Enabling IPv6 as requested on boot commandline (sleeping for 2 seconds)"
1135   modprobe ipv6
1136   # we probably need some time until stateless autoconfiguration has happened
1137   sleep 2
1138   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1139   for DEVICE in `echo "$NETDEVICES"`; do
1140     eindent
1141       einfo "$DEVICE:"
1142       ADDRESSES="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{print $3}')"
1143       COUNT="$(ifconfig $DEVICE | awk '/.*inet6 addr:.*/{ sum += 1};END {print sum }')"
1144       eindent
1145         for ADDR in `echo "$ADDRESSES"` ; do
1146             einfo "$ADDR"
1147         done
1148         if [ "$COUNT" -eq "0" ] ; then
1149            einfo "(none)" ; eend 1
1150         fi
1151       eoutdent
1152     eoutdent
1153   done
1154   eend 0
1155 fi
1156 }
1157 # }}}
1158
1159 # {{{ Fat-Client-Version: DHCP Broadcast for IP address
1160 config_dhcp(){
1161 if checkbootparam "nodhcp"; then
1162   ewarn "Skipping DHCP broadcast/network detection as requested on boot commandline." ; eend 0
1163 else
1164   NETDEVICES="$(awk -F: '/eth.:|tr.:|wlan.:/{print $1}' /proc/net/dev 2>>$DEBUG)"
1165   rm -rf /etc/network/status ; mkdir -p /etc/network/status
1166   for DEVICE in `echo "$NETDEVICES"` ; do
1167     einfo "Network device ${WHITE}${DEVICE}${NORMAL} detected, DHCP broadcasting for IP. (Backgrounding)"
1168     trap 2 3 11
1169     ifconfig $DEVICE up >>$DEBUG 2>&1
1170     ( pump -i $DEVICE >>$DEBUG 2>&1 && echo finished_running_pump > /etc/network/status/$DEVICE ) &
1171     trap "" 2 3 11
1172     sleep 1
1173     eend 0
1174   done
1175   if [ -n "$INSTALLED" ] ; then
1176      ewarn 'If you want to disable automatic DHCP requests set CONFIG_DHCP=no in /etc/grml/autoconfig.'
1177      eend 0
1178   fi
1179 fi
1180 }
1181 # }}}
1182
1183 # {{{ helper functions
1184 findfile(){
1185 FOUND=""
1186 # search all partitions for a file in the root directory
1187 for i in /mnt/[sh]d[a-z] /mnt/[sh]d[a-z][1-9] /mnt/[sh]d[a-z][1-9]?*; do
1188 # See if it's already mounted
1189   [ -f "$i/$1" ] &&  { echo "$i/$1"; return 0; }
1190   if [ -d "$i" ] && mount -r "$i" 2>>$DEBUG; then
1191     [ -f "$i/$1" ] && FOUND="$i/$1"
1192     umount -l "$i" 2>>$DEBUG
1193     [ -n "$FOUND" ] && { echo "$FOUND"; return 0; }
1194   fi
1195 done
1196 return 2
1197 }
1198
1199 fstype(){
1200 case "$(file -s $1)" in
1201   *[Ff][Aa][Tt]*|*[Xx]86*) echo "vfat"; return 0;;
1202   *[Rr][Ee][Ii][Ss][Ee][Rr]*)  echo "reiserfs"; return 0;;
1203   *[Xx][Ff][Ss]*)  echo "xfs"; return 0;;
1204   *[Ee][Xx][Tt]3*) echo "ext3"; return 0;;
1205   *[Ee][Xx][Tt]2*) echo "ext2"; return 0;;
1206   *data*)          echo "invalid"; return 0;;
1207   *) echo "auto"; return 0;;
1208 esac
1209 }
1210
1211 # Try to mount this filesystem read-only, without or with encryption
1212 trymount(){
1213 # Check if already mounted
1214 case "$(cat /proc/mounts)" in *\ $2\ *) return 0;; esac
1215 # Apparently, mount-aes DOES autodetect AES loopback files.
1216 [ -b "$1" ] && { mount -t auto -o ro "$1" "$2" 2>>$DEBUG; RC="$?"; }
1217 # We need to mount crypto-loop files with initial rw support
1218 [ -f "$1" ] && { mount -t auto -o loop,rw "$1" "$2" 2>>$DEBUG; RC="$?"; }
1219 # Mount succeeded?
1220 [ "$RC" = "0" ] && return 0
1221 echo ""
1222 einfo "Filesystem not autodetected, trying to mount $1 with AES256 encryption."
1223 a="y"
1224 while [ "$a" != "n" -a "$a" != "N" ]; do
1225 # We need to mount crypto-loop files with initial rw support
1226  mount -t auto -o loop,rw,encryption=AES256 "$1" "$2" && return 0
1227  echo -n "${RED}Mount failed, retry? [Y/n] ${NORMAL}"
1228  # Problem with ioctl() from getpasswd()?
1229  # read a
1230  read a
1231 done
1232 return 1
1233 }
1234 # }}}
1235
1236 # {{{ CPU-detection
1237 config_cpu(){
1238 if checkbootparam "nocpu"; then
1239   ewarn "Skipping CPU detection as requested on boot commandline." ; eend 0
1240 else
1241   # check module dependencies
1242   cpufreq_check() {
1243    if [ -e /lib64 ] ; then
1244       [ -e /lib/modules/${KERNEL}/kernel/arch/x86_64/kernel/cpufreq ] || return 1
1245    else
1246       [ -e /lib/modules/${KERNEL}/kernel/arch/i386/kernel/cpu/cpufreq -o ! -e /lib/modules/${KERNEL}/kernel/drivers/cpufreq ] || return 1
1247    fi
1248   }
1249
1250   if [[ `grep -c processor /proc/cpuinfo` -gt 1 ]] ; then
1251      einfo "Detecting CPU:"
1252      CPU=$(awk -F: '/^processor/{printf "       Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG)
1253      echo $CPU | sed 's/ \{1,\}/ /g'
1254      eend 0
1255   else
1256      einfo "Detecting CPU: `awk -F: '/^processor/{printf " Processor"$2" is"};/^model name/{printf $2};/^vendor_id/{printf vendor};/^cpu MHz/{printf " %dMHz",int($2)};/^cache size/{printf ","$2" Cache"};/^$/{print ""}' /proc/cpuinfo 2>>$DEBUG` " ; eend 0
1257   fi
1258
1259   # Disclaimer: sorry for the tons of if/then/else... but this makes sure we use:
1260   # * it only if we have the according kernel modules available
1261   # * cpufreq only on laptops (check via /usr/sbin/laptop-detect) and not inside Virtual Box
1262   # * current version of /etc/init.d/loadcpufreq from Debian (to stay in sync)
1263   #   -> parse output of the initscript and output it according to our look'n'feel
1264   # * our own cpufreq-detect.sh if /etc/init.d/loadcpufreq isn't present
1265   if ! cpufreq_check ; then
1266     ewarn "Skipping cpufreq setup as module dependencies are not fulfilled." ; eend 1
1267   else
1268     if /usr/sbin/laptop-detect 1>/dev/null 2>&1 ; then
1269        # Virtual Box supports ACPI and laptop-detect returns with '0', so check for it:
1270        if [ -r /proc/acpi/battery/BAT0/info ] ; then
1271           if grep -q 'OEM info:                innotek' /proc/acpi/battery/BAT0/info ; then
1272              einfo 'Virtual Box detected, skipping cpufreq setup.' ; eend 0
1273              return 0
1274           fi
1275        fi
1276        einfo "Detected Laptop - trying to use cpu frequency scaling:"
1277        eindent
1278        if [ -x /etc/init.d/loadcpufreq ] ; then
1279           SKIP_CPU_GOVERNOR=''
1280           LOADCPUFREQ=$(mktemp)
1281           /etc/init.d/loadcpufreq start >"$LOADCPUFREQ" 2>&1 ; RC=$?
1282           if grep -q FATAL "$LOADCPUFREQ" ; then
1283              eindent
1284                SKIP_CPU_GOVERNOR=1
1285                oldIFS="$IFS"
1286                IFS="
1287 "
1288                 for line in $(grep FATAL "$LOADCPUFREQ" | sed 's/.*FATAL: //; s/ (.*)//') ; do
1289                     eerror "$line" ; eend $RC
1290                 done
1291                 IFS="$oldIFS"
1292              eoutdent
1293            elif grep -q done "$LOADCPUFREQ" ; then
1294              MODULE=$(grep done "$LOADCPUFREQ" | sed 's/.*done (\(.*\))./\1/')
1295              if [ -n "$MODULE" -a "$MODULE" != none ]; then
1296                 einfo "Loading cpufreq kernel module $MODULE" ; eend 0
1297              else
1298                 ewarn "Could not find an appropriate kernel module for cpu frequency scaling." ; eend 1
1299              fi
1300           fi
1301           rm -f $LOADCPUFREQ
1302        elif [ -r /usr/bin/cpufreq-detect.sh ] ; then
1303           . /usr/bin/cpufreq-detect.sh
1304           if [ -n "$MODULE" -a "$MODULE" != none ]; then
1305              einfo "Loading modules ${MODULE}"
1306              modprobe "$MODULE" 1>>$DEBUG || modprobe "$MODULE_FALLBACK" 1>>$DEBUG
1307              RC=$?
1308              if [[ $RC == 0 ]]; then
1309                 eend 0
1310              else
1311                 SKIP_CPU_GOVERNOR=1
1312                 eend $1
1313              fi
1314           else
1315              ewarn "Could not detect an appropriate CPU for use with cpu frequency scaling - skipping." && eend 1
1316           fi # $MODULE
1317        fi # loadcpufreq
1318
1319        if [ -z "$SKIP_CPU_GOVERNOR" ] ; then
1320           einfo "Loading cpufreq_ondemand, setting ondemand governor"
1321           if modprobe cpufreq_ondemand ; RC=$? ; then
1322              for file in $(find /sys/devices/system/cpu/ -name scaling_governor 2>/dev/null) ; do
1323                  echo ondemand > $file
1324              done
1325           fi
1326           eend $RC
1327        fi # cpu-governor
1328
1329        eoutdent
1330
1331     fi # laptop-detect
1332   fi # cpufreq_check
1333 fi # checkbootparam nocpu
1334 }
1335 # }}}
1336
1337 # {{{ autostart of ssh
1338 config_ssh(){
1339 if checkbootparam ssh ; then
1340   SSH_PASSWD="$(getbootparam 'ssh' 2>>$DEBUG)"
1341   einfo "Bootoption passwd found."
1342   if [ -n "$SSH_PASSWD" ] ; then
1343     echo "grml:$SSH_PASSWD" | chpasswd -m
1344     einfo "Starting secure shell server in background."
1345     /etc/init.d/rmnologin start 1>>$DEBUG 2>>$DEBUG
1346     /etc/init.d/ssh start 1>>$DEBUG 2>>$DEBUG &
1347     eend 0
1348   else
1349     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1350   fi
1351   eindent
1352     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1353   eoutdent
1354 fi
1355 }
1356 # }}}
1357
1358 # {{{ set password for user grml
1359 config_passwd(){
1360 if checkbootparam passwd >>$DEBUG 2>&1; then
1361   einfo "Bootoption passwd found."
1362   PASSWD="$(getbootparam 'passwd' 2>>$DEBUG)"
1363   if [ -n "$PASSWD" ] ; then
1364     echo "grml:$PASSWD" | chpasswd -m ; eend $?
1365   else
1366     eerror "No given password for ssh found. Autostart of SSH will not work." ; eend 1
1367   fi
1368   eindent
1369     ewarn "Warning: please change the password for user grml set via bootparameter as soon as possible!"
1370   eoutdent
1371 fi
1372 }
1373 # }}}
1374
1375 # {{{ Check for persistent homedir option and eventually mount /home from there, or use a loopback file.
1376 config_homedir(){
1377 if checkbootparam home ; then
1378    HOMEDIR="$(getbootparam home)"
1379    MYHOMEDEVICE=""
1380    MYHOMEMOUNTPOINT=""
1381    MYHOMEDIR=""
1382    if [ -n "$HOMEDIR" ]; then
1383       einfo "Bootoption home detected." && eend 0
1384       case "$HOMEDIR" in
1385         /dev/*)
1386         MYHOMEDEVICE="${HOMEDIR##/dev/}"
1387         MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1388         MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1389         MYHOMEDIR="/mnt/${HOMEDIR##/dev/}"
1390       ;;
1391         /mnt/*)
1392         MYHOMEDEVICE="${HOMEDIR##/mnt/}"
1393         MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1394         MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1395         MYHOMEDIR="$HOMEDIR"
1396       ;;
1397         [Aa][Uu][Tt][Oo]|[Ss][Cc][Aa][Nn]|[Ff][Ii][Nn][Dd])
1398         MYHOMEDIR="$(findfile grml.img)"
1399         MYHOMEDEVICE="${MYHOMEDIR##/mnt/}"
1400         MYHOMEDEVICE="/dev/${MYHOMEDEVICE%%/*}"
1401         MYHOMEMOUNTPOINT="/mnt/${MYHOMEDEVICE##/dev/}"
1402       ;;
1403       *)
1404         eerror "Invalid home= option '$HOMEDIR' specified (must start with /dev/ or /mnt/ or 'scan')." ; eend 1
1405         eerror "Option ignored." ; eend 1
1406       ;;
1407       esac
1408    fi # -n $HOMEDIR
1409
1410    if [ -n "$MYHOMEDIR" ]; then
1411       if trymount "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"; then
1412          [ -f "$MYHOMEMOUNTPOINT/grml.img" ] && MYHOMEDIR="$MYHOMEMOUNTPOINT/grml.img"
1413          while read device mountpoint fs relax; do
1414            case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1415              case "$fs" in
1416                *[Nn][Tt][Ff][Ss]*)
1417                  umount "$MYHOMEMOUNTPOINT"; eerror "Error: will not mount NTFS filesystem on $MYHOMEDEVICE read/write!" ; eend 1
1418                  break
1419                  ;;
1420                *[Ff][Aa][Tt]*)
1421                  # Note: This currently won't work with encrypted partitions
1422                  umount "$MYHOMEMOUNTPOINT"; mount -t vfat -o rw,uid=grml,gid=grml,umask=002 "$MYHOMEDEVICE" "$MYHOMEMOUNTPOINT"
1423                  if [ ! -f "$MYHOMEDIR" ]; then
1424                     ewarn "WARNING: FAT32 is not a good filesystem option for /home/grml (missing socket/symlink support)."
1425                     ewarn "WARNING: Better use an ext2 loopback file on this device, and boot with home=$MYHOMEDEVICE/grml.img."
1426                  fi
1427                  ;;
1428              esac
1429
1430              if mount -o remount,rw "$MYHOMEMOUNTPOINT"; then
1431                 einfo "Mounting ${WHITE}$MYHOMEDIR${NORMAL} as ${WHITE}/home/grml${NORMAL}."
1432                 if [ -f "$MYHOMEDIR" ]; then
1433                    # It's a loopback file, mount it over the /home/grml directory
1434                    trymount "$MYHOMEDIR" /home/grml
1435                    RC="$?"
1436                    [ "$RC" = "0" ] && ERROR="$(mount -o remount,rw /home/grml 2>&1)"
1437                    RC="$?"
1438                 else
1439                    # Do a --bind mount
1440                    ERROR="$(mount --bind "$MYHOMEDIR" /home/grml 2>&1)"
1441                    RC="$?"
1442                 fi # -f $MYHOMEDIR
1443
1444                 [ "$RC" = "0" ] && eend 0 || ( eerror "${ERROR}" ; eend 1 )
1445
1446              fi #  mount -o remount,rw,...
1447            break
1448            ;;
1449            esac # case "$mountpoint" in *$MYHOMEMOUNTPOINT*)
1450          done <<EOT
1451          $(cat /proc/mounts)
1452 EOT
1453      fi # if trymount ...
1454    fi # -n $MYHOMEDIR
1455 fi # checkbootparam home
1456 }
1457 # }}}
1458
1459 # {{{ Check for scripts on CD-ROM
1460 config_cdrom_scripts(){
1461 if checkbootparam "script"; then
1462    for script in "${LIVECD_PATH}"/scripts/* ; do
1463        einfo " grml script found on CD, executing ${WHITE}${script}${NORMAL}."
1464        . $script
1465    done
1466 fi
1467 }
1468 # }}}
1469
1470 # {{{ Sound
1471 config_mixer(){
1472 if ! [ -x /usr/bin/aumix ] ; then
1473   eerror "aumix binary not available. Can not set sound volumes therefore." ; eend 1
1474 else
1475
1476   if ! [ -r /proc/asound/cards ] ; then
1477      ewarn "No soundcard present, skipping mixer settings therefore." ; eend 0
1478      return
1479   fi
1480
1481   if checkbootparam vol ; then
1482     VOL="$(getbootparam 'vol' 2>>$DEBUG)"
1483     if [ -z "$VOL" ] ; then
1484       eerror "Bootoption vol found but no volume level/parameter given. Using defaults." ; eend 1
1485       VOL='75' # default
1486     fi
1487   else
1488     VOL='75' # default
1489   fi
1490
1491   if checkbootparam nosound ; then
1492     einfo "Muting sound devices on request."
1493     # some IBM notebooks require the following stuff:
1494     if [ -x /usr/bin/amixer ] ; then
1495        if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1496           amixer set Front unmute 1>/dev/null
1497           amixer set Front 0% 1>/dev/null
1498        fi
1499     fi
1500     ERROR=$(aumix -w 0 -v 0 -p 0 -m 0 2>&1) ; RC=$?
1501     if [ -n "$ERROR" ] ; then
1502        eindent
1503        eerror "Problem muting sound devices: $ERROR"
1504        eoutdent
1505     fi
1506     eend $RC
1507   elif [ -z "$INSTALLED" ]; then
1508       einfo "Setting mixer volumes to level ${WHITE}${VOL}${NORMAL}."
1509       # some IBM notebooks require the following stuff:
1510       if [ -x /usr/bin/amixer ] ; then
1511          if amixer get Front 1>/dev/null 2>>$DEBUG ; then
1512             amixer set Front unmute 1>/dev/null
1513             amixer set Front ${VOL}% 1>/dev/null
1514          fi
1515       fi
1516       # by default assume '0' as volume for microphone:
1517       if checkbootparam micvol ; then
1518          MICVOL="$(getbootparam 'micvol' 2>>$DEBUG)"
1519       else
1520          MICVOL=0
1521       fi
1522
1523       # finally set the volumes:
1524       ERROR=$(aumix -w $VOL -v $VOL -p $VOL -m $MICVOL 2>&1) ; RC=$?
1525       if [ -n "$ERROR" ] ; then
1526          eindent
1527          eerror "Problem setting mixer volumes: $ERROR (no soundcard?)"
1528          eoutdent
1529       fi
1530       eend $RC
1531   fi
1532
1533 fi
1534 }
1535 # }}}
1536
1537 # {{{ modem detection
1538 config_modem(){
1539 if checkbootparam "nomodem"; then
1540   ewarn "Skipping check for AC97 modem controller as requested on boot commandline." ; eend 0
1541 else
1542   if [ -x /etc/init.d/sl-modem-daemon ] ; then
1543      if lspci | grep Intel | grep -q "AC'97 Modem Controller" ; then
1544         einfo "AC97 modem controller detected. Start it running 'Start sl-modem-daemon'."
1545         eend 0
1546      fi
1547   fi
1548 fi
1549 }
1550 # }}}
1551
1552 # {{{ keyboard add-ons
1553 config_setkeycodes(){
1554 if checkbootparam "setkeycodes" ; then
1555  einfo "Setting keycodes as requested via bootparameter 'setkeycodes'."
1556   # MS MM keyboard add-on
1557   # fix
1558   setkeycodes e001 126 &>/dev/null
1559   setkeycodes e059 127 &>/dev/null
1560   # fn keys
1561   setkeycodes e03b 59 &>/dev/null
1562   setkeycodes e008 60 &>/dev/null
1563   setkeycodes e007 61 &>/dev/null
1564   setkeycodes e03e 62 &>/dev/null
1565   setkeycodes e03f 63 &>/dev/null
1566   setkeycodes e040 64 &>/dev/null
1567   setkeycodes e041 65 &>/dev/null
1568   setkeycodes e042 66 &>/dev/null
1569   setkeycodes e043 67 &>/dev/null
1570   setkeycodes e023 68 &>/dev/null
1571   setkeycodes e057 87 &>/dev/null
1572   setkeycodes e058 88 &>/dev/null
1573   # hp keycodes
1574   setkeycodes e00a 89 e008 90 &>/dev/null
1575  eend 0
1576 fi
1577 }
1578 # }}}
1579
1580 # {{{ wondershaper
1581 config_wondershaper(){
1582  if checkbootparam "wondershaper" ; then
1583     WONDER="$(getbootparam wondershaper 2>>$DEBUG)"
1584     CMD=wondershaper
1585     DEVICE=""
1586     DOWNSTREAM=""
1587     UPSTREAM=""
1588     if [ -n "$WONDER" ]; then
1589       # Extra options
1590       DEVICE="${WONDER%%,*}"
1591       R="${WONDER#*,}"
1592       if [ -n "$R" -a "$R" != "$WONDER" ]; then
1593         WONDER="$R"
1594         DOWNSTREAM="${WONDER%%,*}"
1595         R="${WONDER#*,}"
1596         if [ -n "$R" -a "$R" != "$WONDER" ]; then
1597           WONDER="$R"
1598           UPSTREAM="${WONDER%%,*}"
1599           R="${WONDER#*,}"
1600         fi
1601       fi
1602     fi
1603     [ -n "$DEVICE" ]     && CMD="$CMD $DEVICE"
1604     [ -n "$DOWNSTREAM" ] && CMD="$CMD $DOWNSTREAM"
1605     [ -n "$UPSTREAM" ]   && CMD="$CMD $UPSTREAM"
1606     einfo "Starting wondershaper (${CMD}) in background."
1607     ( sh -c $CMD & ) && eend 0
1608  fi
1609 }
1610 # }}}
1611
1612 # {{{ syslog-ng
1613 config_syslog(){
1614  if checkbootparam "nosyslog"; then
1615   ewarn "Not starting syslog-ng as requested on boot commandline." ; eend 0
1616  else
1617   einfo "Starting syslog-ng in background."
1618   /etc/init.d/syslog-ng start 1>>$DEBUG &
1619   eend 0
1620  fi
1621 }
1622 # }}}
1623
1624 # {{{ gpm
1625 config_gpm(){
1626  if checkbootparam "nogpm"; then
1627   ewarn "Not starting GPM as requested on boot commandline." ; eend 0
1628  else
1629   einfo "Starting gpm in background."
1630 #  /etc/init.d/gpm start 1>>$DEBUG &
1631   ( while [ ! -e /dev/psaux ]; do sleep 5; done; /etc/init.d/gpm start 1>>$DEBUG ) &
1632   eend 0
1633  fi
1634 }
1635 # }}}
1636
1637 # {{{ services
1638 config_services(){
1639  if checkbootparam "services" ; then
1640     SERVICE="$(getbootparam services 2>>$DEBUG)"
1641     SERVICELIST=$(echo "$SERVICE" | sed 's/,/\\n/g')
1642     SERVICENL=$(echo "$SERVICE" | sed 's/,/ /g')
1643     einfo "Starting service(s) ${SERVICENL} in background."
1644     for service in $(echo -e $SERVICELIST) ; do
1645        /etc/init.d/${service} start 1>>$DEBUG &
1646     done
1647     [ "$?" == "0" ] ; eend $?
1648  fi
1649 }
1650 # }}}
1651
1652 # {{{ config files
1653 config_netconfig(){
1654  if checkbootparam netconfig ; then
1655   CONFIG="$(getbootparam 'netconfig' 2>>$DEBUG)"
1656   CONFIGFILE='/tmp/netconfig.grml'
1657
1658   getconfig() {
1659   wget --timeout=10 --dns-timeout=10  --connect-timeout=10 \
1660        --read-timeout=10 $CONFIG -O $CONFIGFILE && return 0 || return 1
1661   }
1662   einfo "Trying to get ${WHITE}${CONFIG}${NORMAL}"
1663   counter=10
1664   while ! getconfig && [[ "$counter" != 0 ]] ; do
1665     echo -n "Sleeping for 5 seconds and trying to get config again... "
1666     counter=$(( counter-1 ))
1667     echo "$counter tries left" ; sleep 1
1668   done
1669   if [ -r "$CONFIGFILE" ] ; then
1670     einfo "Downloading was successfull." ; eend 0
1671     einfo "md5sum of ${WHITE}${CONFIG}${NORMAL}: "
1672     md5sum $CONFIGFILE ; eend 0
1673     cd / && einfo "Unpacking ${WHITE}${CONFIGFILE}${NORMAL}:" && /usr/bin/unp $CONFIGFILE $EXTRACTOPTIONS ; eend $?
1674   else
1675     einfo "Sorry, could not fetch $CONFIG" ; eend 1
1676   fi
1677  fi
1678 }
1679 # }}}
1680
1681 # {{{ blindsound
1682 config_blindsound(){
1683  if checkbootparam "blind" ; then
1684     beep
1685     flite -o play -t "welcome to the gremel system"
1686  fi
1687 }
1688 # }}}
1689
1690 # {{{ welcome sound
1691 config_welcome(){
1692  if checkbootparam welcome ; then
1693   flite -o play -t "welcome to the gremel system"
1694  fi
1695 }
1696 # }}}
1697
1698 # {{{ fix/workaround for unionfs
1699 fix_unionfs(){
1700   if [ -z "$INSTALLED" ]; then
1701    touch /var/cache/apt/*cache.bin
1702   fi
1703 }
1704 # }}}
1705
1706 # {{{ create all /mnt-directories
1707 create_mnt_dirs(){
1708   ewarn "create_mnt_dirs is deprecated as grml-rebuildfstab does all we need."
1709   ewarn "Please set CONFIG_CREATE_MNT_DIRS='no' in /etc/grml/autoconfig" ; eend 0
1710 }
1711 # }}}
1712
1713 # {{{ start X window system via grml-x
1714 config_x_startup(){
1715 if checkbootparam startx ; then
1716  if [ -x /usr/X11R6/bin/X ] ; then
1717   if [ -z "$INSTALLED" ] ; then
1718    WINDOWMANAGER="$(getbootparam 'startx' 2>>$DEBUG)"
1719    if [ -z "$WINDOWMANAGER" ] ; then
1720      einfo "No window manager specified. Taking ${WHITE}wm-ng${NORMAL} as default." && eend 0
1721      WINDOWMANAGER="wm-ng"
1722    else
1723      einfo "Window manager ${WHITE}${WINDOWMANAGER}${NORMAL} found as bootoption." && eend 0
1724    fi
1725    einfo "Changing to runlevel 5 for starting grml-x ${WINDOWMANAGER}. Just exit X windows system to get full featured consoles."
1726    config_userfstab || fstabuser='grml'
1727  cat>|/etc/init.d/xstartup<<EOF
1728 #!/bin/sh
1729 # su - $fstabuser -c 'grml-x "$WINDOWMANAGER"'
1730 sudo -u $fstabuser -i /usr/bin/grml-x $WINDOWMANAGER 1>>$DEBUG
1731 EOF
1732    chmod 755 /etc/init.d/xstartup
1733
1734    # adjust inittab for xstartup
1735    if grep -q '^6:' /etc/inittab ; then
1736       sed -i 's|^6:.*|6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"|' /etc/inittab
1737    else # just append tty6 to inittab if no definition is present:
1738       echo '6:2345:respawn:/bin/zsh --login -c "/etc/init.d/xstartup ; /bin/zsh"' >> /etc/inittab
1739    fi
1740
1741    /sbin/telinit q ; eend $?
1742
1743    if grep -q '^allowed_users=' /etc/X11/Xwrapper.config ; then
1744       sed -i 's/^allowed_users=.*/allowed_users=anybody/' /etc/X11/Xwrapper.config
1745    else
1746       echo 'allowed_users=anybody' >> /etc/X11/Xwrapper.config
1747    fi
1748
1749   else
1750     eerror "We are not running from CD - startx will not work, skipping it.
1751      Please use something like xdm, gdm or kdm for starting X on a harddisk system!" ; eend 1
1752   fi
1753  else
1754    eerror "/usr/X11R6/bin/X is not present on this grml flavour.
1755    Boot parameter startx does not work therefore." ; eend 1
1756  fi
1757 fi
1758 }
1759 # }}}
1760
1761 # {{{ configuration framework
1762 config_extract(){
1763 if checkbootparam extract ; then
1764  EXTRACT="$(getbootparam 'extract' 2>>$DEBUG)"
1765  EXTRACTOPTIONS="-- -x $EXTRACT"
1766 fi
1767 }
1768
1769 config_automount(){
1770 if checkbootparam noautoconfig || checkbootparam forensic ; then
1771   ewarn "Skipping running automount of device(s) labeled GRMLCFG as requested." ; eend 0
1772 else
1773  if [ -z "$INSTALLED" ] ; then
1774   einfo "Searching for device(s) labeled with GRMLCFG." ; eend 0
1775   eindent
1776   [ -d /mnt/grml ] || mkdir /mnt/grml
1777   umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1778 # We do need the following fix so floppy disk is available to blkid in any case :-/
1779   if [ -r /dev/fd0 ] ; then
1780      einfo "Floppy device detected. Trying to access floppy disk. (Disable this via boot option: noautoconfig)"
1781 #     dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1
1782      if timeout 4 dd if=/dev/fd0 of=/dev/null bs=512 count=1 1>>$DEBUG 2>&1 ; then
1783         blkid /dev/fd0 1>>$DEBUG 2>&1
1784      fi
1785   fi
1786   DEVICE=$(blkid -t LABEL=GRMLCFG | head -1 | awk -F: '{print $1}')
1787   [ -n "$DEVICE" ] && mount -t auto -o ro $DEVICE /mnt/grml ; RC="$?"
1788   if [[ $RC == 0 ]]; then
1789     einfo "Mounting device $DEVICE labeled GRMLCFG succeeded." ; eend 0
1790
1791     CONFIG=''
1792     CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1793     if [ -n "$CONFIG" ]; then
1794       einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1795       cd /
1796       unp $CONFIG $EXTRACTOPTIONS ; eend $?
1797     else
1798       ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1799     fi
1800
1801     SCRIPT=''
1802     SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1803     if [ -n "$SCRIPT" ]; then
1804       einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1805       $SCRIPT ; eend $?
1806     fi
1807     grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1808   else
1809     ewarn "No devices with label GRMLCFG found." ; eend 0
1810   fi
1811   eoutdent
1812  fi
1813 fi
1814 }
1815
1816 config_myconfig(){
1817
1818 if checkbootparam "config" ; then
1819   CONFIG="$(getbootparam 'config' 2>>$DEBUG)"
1820   [ -z "$CONFIG" ] && CONFIG='config.tbz'
1821   einfo "Bootoption config found. config is set to: $CONFIG"
1822   eindent
1823     einfo "Trying to extract configuration file ${CONFIG}:"
1824     cd / && unp "${LIVECD_PATH}"/config/$CONFIG $EXTRACTOPTIONS ; eend $?
1825   eoutdent
1826 fi
1827
1828 if checkbootparam myconfig ; then
1829  MOUNTDEVICE="$(getbootparam 'myconfig' 2>>$DEBUG)"
1830  if [ -n "$MOUNTDEVICE" ]; then
1831    if checkbootparam file ; then
1832     FILENAME="$(getbootparam 'file' 2>>$DEBUG)"
1833     [ -n "$FILENAME" ] || FILENAME='config.tbz'
1834    fi
1835    [ -d /mnt/grml ] || mkdir /mnt/grml
1836    umount /mnt/grml 1>>$DEBUG 2>&1 # make sure it is not mounted
1837    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1838     if [[ $RC == 0 ]]; then
1839       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1840       eindent
1841       CONFIG=''
1842       CONFIG="$(/bin/ls -1d /mnt/grml/[Cc][Oo][Nn][Ff][Ii][Gg].[Tt][Bb][Zz] 2>>$DEBUG)"
1843       if [ -n "$CONFIG" ]; then
1844         einfo "Found file ${WHITE}${CONFIG}${NORMAL} - trying to extract it."
1845         cd /
1846         unp $CONFIG $EXTRACTOPTIONS ; eend $?
1847       else
1848         ewarn "Sorry, could not find file config.tbz on device with label GRMLCFG." ; eend 1
1849       fi
1850
1851       SCRIPT=''
1852       SCRIPT="$(/bin/ls -1d /mnt/grml/[Gg][Rr][Mm][Ll].[Ss][Hh] 2>>$DEBUG)"
1853       if [ -n "$SCRIPT" ]; then
1854         einfo "Found script ${WHITE}${SCRIPT}${NORMAL} - trying to execute it."
1855         $SCRIPT ; eend $?
1856       fi
1857       eoutdent
1858     else
1859       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1860     fi # mount $MOUNTDEVICE
1861    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1862  else
1863    einfo "Sorry, no device for bootoption myconfig provided. Skipping." ; eend 1
1864  fi # [ -n "$MOUNTDEVICE" ]
1865 fi # checkbootparam myconfig
1866
1867 if checkbootparam "partconf" ; then
1868  MOUNTDEVICE="$(getbootparam 'partconf' 2>>$DEBUG)"
1869  if [ -n "$MOUNTDEVICE" ]; then
1870    [ -d /mnt/grml ] || mkdir /mnt/grml
1871    mount -o ro -t auto $MOUNTDEVICE /mnt/grml ; RC="$?"
1872     if [[ $RC == 0 ]]; then
1873       einfo "Successfully mounted $MOUNTDEVICE to /mnt/grml (readonly)." ; eend 0
1874       einfo "Copying files from $MOUNTDEVICE over grml system."
1875       for file in `cat /etc/grml/partconf` ; do
1876         [ -d /mnt/grml/$file ] && cp -a /mnt/grml/${file}* ${file} && echo "copied: $file"
1877         [ -f /mnt/grml/$file ] && cp -a /mnt/grml/${file}  ${file} && echo "copied: $file"
1878       done && eend 0
1879     else
1880       einfo "Could not mount $MOUNTDEVICE to /mnt/grml - sorry." ; eend 1
1881     fi # mount $MOUNTDEVICE
1882    grep -q '/mnt/grml' /proc/mounts && umount /mnt/grml
1883  else
1884    einfo "Sorry, no device for bootoption partconf provided. Skipping." ; eend 1
1885  fi # [ -n "$MOUNTDEVICE" ]
1886 fi
1887 }
1888 # }}}
1889
1890 # {{{ /cdrom/.*-options
1891 config_debs(){
1892 if checkbootparam "debs" ; then
1893    DEBS="$(getbootparam 'debs' 2>>$DEBUG)"
1894    einfo "Tring to install debian package(s) ${DEBS}"
1895    dpkg -i "${LIVECD_PATH}"/debs/$DEBS* ; eend $?
1896 fi
1897 }
1898
1899 config_scripts(){
1900 if checkbootparam "scripts" ; then
1901    SCRIPTS="$(getbootparam 'scripts' 2>>$DEBUG)"
1902    [ -z "$SCRIPTS" ] && SCRIPTS='grml.sh'
1903    einfo "Bootparameter scripts found. Trying to execute ${SCRIPTS}:"
1904    sh -c "${LIVECD_PATH}"/scripts/$SCRIPTS ; eend $?
1905 fi
1906 }
1907 # }}}
1908
1909 # {{{ mypath
1910 config_mypath(){
1911 if checkbootparam "mypath" ; then
1912    MY_PATH="$(getbootparam 'mypath' 2>>$DEBUG)"
1913    einfo "Bootparameter mypath found, adding ${MY_PATH} to /etc/grml/my_path"
1914    touch /etc/grml/my_path
1915    chmod 644 /etc/grml/my_path
1916    echo "$MY_PATH" >> /etc/grml/my_path ; eend $?
1917 fi
1918 }
1919 # }}}
1920
1921 # {{{ distcc
1922 config_distcc(){
1923 if checkbootparam "distcc" ; then
1924  OPTIONS="$(getbootparam distcc 2>>$DEBUG)"
1925  if [ -n "$OPTIONS" ]; then
1926     NET=""
1927     INTERFACE=""
1928     if [ -n "$OPTIONS" ]; then
1929       NET="${OPTIONS%%,*}"
1930       R="${OPTIONS#*,}"
1931       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
1932         OPTIONS="$R"
1933         INTERFACE="${OPTIONS%%,*}"
1934         R="${OPTIONS#*,}"
1935       fi
1936     fi
1937  fi
1938  CONFIG=/etc/default/distcc
1939  sed -i "s#^STARTDISTCC=.*#STARTDISTCC=YES#"  $CONFIG
1940  sed -i "s#^ALLOWEDNETS=.*#ALLOWEDNETS=$NET#" $CONFIG
1941
1942  if [ -n "$INTERFACE" ] ; then
1943    IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1944
1945    counter=10
1946    while [ -z "$IP" ] && [[ "$counter" != 0 ]] ; do
1947      counter=$(( counter-1 ))
1948      ewarn "No ip address for $INTERFACE found. Sleeping for 3 seconds. $counter tries left."
1949      sleep 3
1950      IP=$(LANG=C ifconfig $INTERFACE | gawk -F: /"inet addr"/'{print $2}' | gawk '{print $1}')
1951    done
1952  fi
1953
1954  if [ -n "$IP" ] ; then
1955    sed -i "s#^LISTENER=.*#LISTENER=$IP#"      $CONFIG
1956
1957    einfo "Bootoption distcc found. Preparing setup for distcc daemon."
1958    eindent
1959     id distccd >/dev/null 2>&1 || \
1960     (
1961       einfo "Creating distcc user" ; \
1962       adduser --quiet --system --ingroup nogroup --home / --no-create-home distccd ; eend $?
1963     )
1964
1965     einfo "Starting distcc for network ${NET}, listening on ${IP}."
1966    /etc/init.d/distcc start 1>/dev/null ; eend $?
1967    eoutdent
1968  else
1969    eerror "No ip address for $INTERFACE found. distcc can not be used without it." ; eend 1
1970  fi
1971 fi
1972
1973 if checkbootparam "gcc"; then
1974  GCC="$(getbootparam gcc 2>>$DEBUG)"
1975  eindent
1976  einfo "Pointing /usr/bin/gcc to /usr/bin/gcc-${GCC}."
1977  eoutdent
1978  rm -f /usr/bin/gcc
1979  ln -s /usr/bin/gcc-${GCC} /usr/bin/gcc ; eend $?
1980 fi
1981
1982 if checkbootparam "gpp"; then
1983  GPP="$(getbootparam gpp 2>>$DEBUG)"
1984  eindent
1985   einfo "Pointing /usr/bin/g++ to /usr/bin/g++-${GPP}."
1986   if [ -x /usr/bin/g++-${GPP} ] ; then
1987      rm -f /usr/bin/g++
1988      ln -s /usr/bin/g++-${GPP} /usr/bin/g++ ; eend $?
1989   fi
1990   einfo "Pointing /usr/bin/cpp to /usr/bin/cpp-${GPP}."
1991   if [ -x /usr/bin/cpp-${GPP} ] ; then
1992      rm -f /usr/bin/cpp
1993      ln -s /usr/bin/cpp-${GPP} /usr/bin/cpp ; eend $?
1994   fi
1995  eoutdent
1996 fi
1997
1998 }
1999 # }}}
2000
2001 # {{{ load modules
2002 # Notice: use it only on live-cd system, if running from harddisk please
2003 # add modules to /etc/modules and activate /etc/init.d/module-init-tools
2004 # in /etc/runlevel.conf
2005 config_modules(){
2006 MODULES_FILE=/etc/grml/modules
2007 if checkbootparam nomodules ; then
2008   ewarn "Skipping loading of modules defined in ${MODULES_FILE} as requested." ; eend 0
2009 elif [ -z "$INSTALLED" ]; then
2010  if [ -r $MODULES_FILE ] ; then
2011   einfo "Loading modules specified in ${MODULES_FILE}:"
2012   eindent
2013   grep '^[^#]' $MODULES_FILE | \
2014   while read module args; do
2015     [ "$module" ] || continue
2016       einfo "${module}"
2017       modprobe $module $args ; eend $?
2018   done
2019   eoutdent
2020  else
2021   ewarn "File $MODULES_FILE does not exist. Skipping loading of specific modules." ; eend 1
2022  fi
2023 fi
2024 }
2025 # }}}
2026
2027 # {{{ 915resolution
2028 config_915resolution(){
2029 if checkbootparam "915resolution" ; then
2030  OPTIONS="$(getbootparam 915resolution 2>>$DEBUG)"
2031   if [ -x /usr/sbin/915resolution ]; then
2032     CMD=915resolution
2033     MODE=""
2034     XRESO=""
2035     YRESO=""
2036     if [ -n "$OPTIONS" ]; then
2037       # Extra options
2038       MODE="${OPTIONS%%,*}"
2039       R="${OPTIONS#*,}"
2040       if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2041         OPTIONS="$R"
2042         XRESO="${OPTIONS%%,*}"
2043         R="${OPTIONS#*,}"
2044         if [ -n "$R" -a "$R" != "$OPTIONS" ]; then
2045           OPTIONS="$R"
2046           YRESO="${OPTIONS%%,*}"
2047           R="${OPTIONS#*,}"
2048         fi
2049       fi
2050     fi
2051     einfo "Running 915resolution with options ${MODE} ${XRESO} ${YRESO}."
2052     [ -n "$MODE" ] && [ -n "$XRESO"  ] && [ -n "$YRESO" ]  && ( sh -c "$CMD $MODE $XRESO $YRESO" & )
2053     eend 0
2054   fi
2055 fi
2056 }
2057 # }}}
2058
2059 # {{{ SW-RAID
2060 config_swraid(){
2061   if [ -z "$INSTALLED" ] ; then
2062   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2063   if checkbootparam 'noraid'   || checkbootparam 'noswraid' -o \
2064      checkbootparam 'forensic' || checkbootparam 'raid=noautodetect' ; then
2065      ewarn "Skipping SW-RAID code as requested on boot commandline." ; eend 0
2066   else
2067     if ! [ -x /sbin/mdadm ] ; then
2068        eerror "mdadm not available, can not execute it." ; eend 1
2069     else
2070
2071        # if ! egrep -qv '^(MAILADDR.*|#.*|)$' /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2072        # find out whether we have a valid configuration file already
2073        if ! grep -q ARRAY /etc/mdadm/mdadm.conf 2>>$DEBUG ; then
2074           einfo "Creating /etc/mdadm/mdadm.conf for use with mdadm."
2075           [ -r /etc/mdadm/mdadm.conf ] && mv /etc/mdadm/mdadm.conf /etc/mdadm/mdadm.conf.old
2076           MDADM_MAILADDR__='root' /usr/share/mdadm/mkconf > /etc/mdadm/mdadm.conf ; eend $?
2077         else
2078           ewarn "/etc/mdadm/mdadm.conf looks like a configured mdadm setup, will not touch it." ; eend 0
2079        fi
2080
2081        if ! checkbootparam 'swraid' ; then
2082           eindent
2083           einfo "Just run 'Start mdadm-raid' to assemble md arrays or boot using 'swraid' as bootoption for autostart."
2084           eoutdent
2085        else
2086           einfo "Bootoption swraid found. Searching for software RAID arrays:"
2087           eindent
2088            IFSOLD=${IFS:-}
2089            IFS='
2090 '
2091            for line in $(mdadm --assemble --scan --auto=yes --symlink=no 2>&1) ; do
2092                case $line in
2093                  *'No arrays found'*)
2094                    ewarn "$line" ; eend 0
2095                    ;;
2096                  *)
2097                    einfo "$line" ; eend 0
2098                    ;;
2099                esac
2100            done
2101            IFS=$IFSOLD
2102          eoutdent
2103
2104          if [ -r /proc/mdstat ] ; then
2105             eindent
2106             MDSTAT=$(grep '^md[0-9]' /proc/mdstat)
2107             if [ -z "$MDSTAT" ] ; then
2108                ewarn "No active arrays found" ; eend 0
2109             else
2110                IFSOLD=${IFS:-}
2111                IFS='
2112 '
2113                for line in $(grep '^md[0-9]' /proc/mdstat) ; do
2114                    einfo "active arrays: $line" ; eend 0
2115                done
2116                IFS=$IFSOLD
2117             fi
2118             eoutdent
2119          fi # /proc/mdstat
2120        fi # bootoption swraid
2121
2122      fi # is /sbin/mdadm executable?
2123   fi # check for bootoptions
2124   fi # run only in live-cd mode
2125 }
2126 # }}}
2127
2128 # {{{ LVM (Logical Volumes)
2129 config_lvm(){
2130   if [ -z "$INSTALLED" ] ; then
2131   # notice: checkbootparam "forensic" is just for users who don't know how to really use the bootoption
2132   if checkbootparam 'nolvm' ; then
2133      ewarn "Skipping LVM code as requested on boot commandline." ; eend 0
2134   else
2135     # Debian etch provides /etc/init.d/lvm only, newer suites provide /etc/init.d/lvm2
2136     if ! [ -x /sbin/lvm -a -x /sbin/lvdisplay ] || ! [ -x /etc/init.d/lvm2 -o -x /etc/init.d/lvm ] ; then
2137        eerror "LVM not available, can not execute it." ; eend 1
2138     else
2139        if lvdisplay 2>&1 | grep -v 'No volume groups found' 1>/dev/null 2>&1 ; then
2140           einfo "You seem to have logical volumes (LVM) on your system."
2141           eindent
2142           einfo "Just run 'Start lvm2' to activate them or boot using 'lvm' as bootoption for autostart."
2143           eend 0
2144           if checkbootparam 'lvm' ; then
2145              einfo "Bootoption LVM found. Searching for logical volumes:"
2146              /etc/init.d/lvm2 start ; eend $?
2147           fi
2148           eoutdent
2149        fi
2150     fi # check for lvm binary
2151   fi # check for bootoption nolvm
2152   fi # run only in live-cd mode
2153 }
2154 # }}}
2155
2156 # {{{ debnet: setup network based on an existing one found on a partition
2157 config_debnet(){
2158 if checkbootparam "debnet" ; then
2159  iszsh && setopt shwordsplit
2160  DEVICES="$(< /proc/partitions tail -n +3 | awk '{print "/dev/"$4}' | tr "\n" " ")"
2161  DEVICES="$DEVICES $(ls /dev/mapper/*)"
2162  FOUND_DEBNET=""
2163
2164  einfo "Bootoption 'debnet' found. Searching for Debian network configuration: "
2165  eindent
2166  if ! mount | grep '/mnt ' 1>/dev/null 2>&1 ; then
2167     for i in $DEVICES; do
2168      if mount -o ro -t auto "$i" /mnt >/dev/null 2>&1; then
2169          einfo "Scanning on $i"
2170        if [ -f /mnt/etc/network/interfaces ]; then
2171          einfo "/etc/network/interfaces found on ${i}" ; eend 0
2172          FOUND_DEBNET="$i"
2173          break
2174        fi
2175        umount /mnt
2176      fi
2177     done
2178
2179    if [ -n "$FOUND_DEBNET" ]; then
2180      einfo "Stopping network."
2181        pump -k 1>/dev/null 2>&1
2182        /etc/init.d/networking stop 1>/dev/null 2>&1 ; eend $?
2183      einfo "Copying Debian network configuration from $FOUND_DEBNET to running system."
2184        rm -rf /etc/network/run
2185        cp -a /mnt/etc/network /etc
2186        rm -rf /etc/network/run
2187        mkdir /etc/network/run
2188        umount /mnt ; eend $?
2189      einfo "Starting network."
2190        /etc/init.d/networking start ; eend $?
2191    else
2192      eerror "/etc/network/interfaces not found." ; eend 1
2193    fi
2194    eoutdent
2195  else
2196   eerror "Error: /mnt already mounted." ; eend 1
2197  fi
2198 fi
2199 }
2200 # }}}
2201
2202 # {{{ check for broken ipw3945 driver which causes problems (especially on hd install)
2203 config_ipw3945() {
2204   if grep -q ipw3945 /proc/modules ; then
2205      if ! iwconfig 2>/dev/null| grep -qe 'IEEE 802' -qe 'unassociated' ; then
2206         ewarn "Broken ipw3945 network interface found, reloading module."
2207         rmmod ipw3945
2208         modprobe ipw3945
2209         eend $?
2210      fi
2211   fi
2212 }
2213 # }}}
2214
2215 # {{{ disable console blanking
2216 config_blanking(){
2217 if checkbootparam "noblank" ; then
2218   einfo "Bootoption noblank found. Disabling monitor blanking."
2219   setterm -blank 0 ; eend $?
2220 fi
2221 }
2222 # }}}
2223
2224 # {{{ grml2hd: automatic installation
2225 config_grml2hd(){
2226
2227 if stringinstring "BOOT_IMAGE=grml2hd " "$CMDLINE" ; then
2228
2229 if checkbootparam "user" ; then
2230    NEWUSER=''
2231    NEWUSER="$(getbootparam 'user' 2>>$DEBUG)"
2232    sed -i "s/^NEWUSER=.*/NEWUSER=$NEWUSER/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2233 fi
2234
2235 if checkbootparam "filesystem" ; then
2236    FILESYSTEM=''
2237    FILESYSTEM="$(getbootparam 'filesystem' 2>>$DEBUG)"
2238    sed -i "s/^FILESYSTEM=.*/FILESYSTEM=$FILESYSTEM/" /etc/grml2hd/config || export GRML2HD_FAIL=1
2239 fi
2240
2241 if checkbootparam "partition" ; then
2242    PARTITION=''
2243    PARTITION="$(getbootparam 'partition' 2>>$DEBUG)"
2244    # notice: the following checks whether the given partition is available, if not the skip
2245    # execution of grml2hd as it might result in data loss...
2246    if [ -r $PARTITION ] ; then
2247       sed -i "s#^PARTITION=.*#PARTITION=$PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2248    else
2249       ewarn "Partition $PARTITION does not exist. Skipping execution of grml2hd therefore." ; eend 1
2250    fi
2251 fi
2252
2253 if checkbootparam "mbr" ; then
2254    BOOT_PARTITION=''
2255    BOOT_PARTITION="$(getbootparam 'mbr' 2>>$DEBUG)"
2256    sed -i "s#^BOOT_PARTITION=.*#BOOT_PARTITION=$BOOT_PARTITION#" /etc/grml2hd/config || export GRML2HD_FAIL=1
2257 fi
2258
2259 cat>|/usr/bin/grml2hd_noninteractive<<EOF
2260 #!/bin/sh
2261 GRML2HD_NONINTERACTIVE='yes' grml2hd
2262 EOF
2263
2264 chmod 755 /usr/bin/grml2hd_noninteractive
2265 einfo "Bootoption grml2hd found. Running automatic installation via grml2hd using /etc/grml2hd/config." && eend 0
2266 if [ -z "$GRML2HD_FAIL" ] ; then
2267    screen /usr/bin/grml2hd_noninteractive ; einfo "Invoking a shell, just exit to continue booting..." ; /bin/zsh
2268 else
2269    ewarn "There was an error adjusting /etc/grml2hd/config. Skipping execution of grml2hd for security reasons." ; eend 1
2270 fi
2271
2272 fi # if stringinstring "BOOT_IMAGE=grml2hd ...
2273 }
2274 # }}}
2275
2276 # {{{ debootstrap: automatic installation
2277 config_debootstrap(){
2278
2279 if stringinstring "BOOT_IMAGE=debian2hd " "$CMDLINE" ; then
2280
2281 einfo "Bootoption debian2hd found. Setting up environment for automatic installation via grml-debootstrap." ; eend 0
2282
2283 if ! [ -x /usr/sbin/grml-debootstrap ] ; then
2284    eindent
2285    eerror "Bootoption debian2hd found, but grml-debootstrap is not available." ; eend 1
2286    eoutdent
2287    exit 1
2288 fi
2289
2290 if checkbootparam "target" ; then
2291   TARGET=''
2292   TARGET="$(getbootparam 'target' 2>>$DEBUG)"
2293   # notice: the following checks whether the given partition is available, if not the skip
2294   # execution of grml-debootstrap as it might result in data loss...
2295   if ! [ -r "$TARGET" ] ; then
2296      eerror "Target $TARGET does not exist. Skipping execution of grml-debootstrap therefore." ; eend 1
2297   fi
2298 else
2299   eindent
2300   eerror "No bootoption named target found, can not continue execution of grml-debootstrap." ; eend 1
2301   eoutdent
2302   exit 1
2303 fi
2304
2305 if checkbootparam "grub" ; then
2306   GRUB=''
2307   GRUB="$(getbootparam 'grub' 2>>$DEBUG)"
2308 fi
2309
2310 if checkbootparam "groot" ; then
2311   GROOT=''
2312   GROOT="$(getbootparam 'groot' 2>>$DEBUG)"
2313 fi
2314
2315 if checkbootparam "release" ; then
2316   RELEASE=''
2317   RELEASE="$(getbootparam 'release' 2>>$DEBUG)"
2318 fi
2319
2320 if checkbootparam "mirror" ; then
2321   MIRROR=''
2322   MIRROR="$(getbootparam 'mirror' 2>>$DEBUG)"
2323 fi
2324
2325 if checkbootparam "boot_append" ; then
2326   BOOT_APPEND=''
2327   BOOT_APPEND="$(getbootparam 'boot_append' 2>>$DEBUG)"
2328 fi
2329
2330 if checkbootparam "password" ; then
2331   PASSWORD=''
2332   PASSWORD="$(getbootparam 'password' 2>>$DEBUG)"
2333 fi
2334
2335 # now check which options are available
2336 if [ -n "TARGET" ] ; then
2337    TARGETCMD="--target $TARGET"
2338 else
2339    TARGETCMD=''
2340    eindent
2341    eerror "Target not set via bootoption. Skipping execution of grml-debootstrap therefore."; eend 1
2342    eoutdent
2343    exit 1
2344 fi
2345 [ -n "$GRUB" ]     && GRUBCMD="--grub $GRUB"               || GRUBCMD=''
2346 [ -n "$GROOT" ]    && GROOTCMD="--groot $GROOT"            || GROOTCMD=''
2347 [ -n "$RELEASE" ]  && RELEASECMD="--release $RELEASE"      || RELEASECMD=''
2348 [ -n "$MIRROR" ]   && MIRRORCMD="--mirror $MIRROR"         || MIRRORCMD=''
2349 [ -n "$PASSWORD" ] && PASSWORDCMD="--password $PASSWORD"   || PASSWORDCMD=''
2350 [ -n "$BOOT_APPEND" ] && BOOT_APPEND="--boot_append $BOOT_APPEND" || BOOT_APPEND=''
2351
2352 # and finally write script and execute it
2353 cat>|/usr/bin/grml-debootstrap_noninteractive<<EOF
2354 #!/bin/sh
2355 AUTOINSTALL='yes' grml-debootstrap $TARGETCMD $GRUBCMD $GROOTCMD $RELEASECMD $MIRRORCMD $PASSWORDCMD $BOOT_APPEND
2356 EOF
2357
2358 chmod 750  /usr/bin/grml-debootstrap_noninteractive
2359
2360 screen /usr/bin/grml-debootstrap_noninteractive
2361 einfo "Invoking a shell, just exit to continue booting..."
2362 /bin/zsh
2363
2364 fi # stringinstring "BOOT_IMAGE=debian2hd
2365 }
2366 # }}}
2367
2368 # {{{ Support customization
2369 config_distri(){
2370 if checkbootparam "distri"; then
2371   DISTRI="$(getbootparam 'distri' 2>>$DEBUG)"
2372   if [ -r "${LIVECD_PATH}"/desktop/"$DISTRI".jpg ] ; then
2373      [ -n "$BOOTDEBUG" ] && einfo "Debug: bootoption distri found and file ${LIVECD_PATH}/desktop/${DISTRI} present" && eend 0
2374      # make sure the desktop.jpg file is not a symlink, so copying does not file then
2375      [ -L /usr/share/grml/desktop.jpg ] && rm /usr/share/grml/desktop.jpg
2376      cp "${LIVECD_PATH}"/desktop/"$DISTRI".jpg /usr/share/grml/desktop.jpg
2377   fi
2378 fi
2379 }
2380 # }}}
2381
2382 ### {{{ backwards compatible stuff
2383 config_environment(){
2384   ewarn "config_environment is deprecated. Please set CONFIG_ENVIRONMENT in /etc/grml/autoconfig to 'no'." ; eend 0
2385 }
2386 config_keyboard(){
2387   ewarn "config_keyboard is deprecated. Please set CONFIG_KEYBOARD in /etc/grml/autoconfig to 'no'." ; eend 0
2388 }
2389 # }}}
2390
2391 ## END OF FILE #################################################################
2392 # vim:foldmethod=marker expandtab ai ft=zsh shiftwidth=3